      SUBROUTINE SMATRIX1(P,ANS)
C     
C     Generated by MadGraph5_aMC@NLO v. 3.2.0, 2021-08-22
C     By the MadGraph5_aMC@NLO Development Team
C     Visit launchpad.net/madgraph5 and amcatnlo.web.cern.ch
C     
C     MadGraph5_aMC@NLO for Madevent Version
C     
C     Returns amplitude squared -- no average over initial
C      state/symmetry factor
C     and helicities
C     for the point in phase space P(0:3,NEXTERNAL)
C     
C     Process: mu+ mu- > b b~ b b~ vm vm~ WEIGHTED<=10 @1
C     
      USE DISCRETESAMPLER
      IMPLICIT NONE
C     
C     CONSTANTS
C     
      INCLUDE 'genps.inc'
      INCLUDE 'maxconfigs.inc'
      INCLUDE 'nexternal.inc'
      INCLUDE 'maxamps.inc'
      INTEGER                 NCOMB
      PARAMETER (             NCOMB=256)
      INTEGER    NGRAPHS
      PARAMETER (NGRAPHS=220)
      INTEGER    NDIAGS
      PARAMETER (NDIAGS=220)
      INTEGER    THEL
      PARAMETER (THEL=2*NCOMB)
C     
C     ARGUMENTS 
C     
      REAL*8 P(0:3,NEXTERNAL),ANS
C     
C     global (due to reading writting) 
C     
      LOGICAL GOODHEL(NCOMB,2)
      INTEGER NTRY(2)
      COMMON/BLOCK_GOODHEL/NTRY,GOODHEL

C     
C     LOCAL VARIABLES 
C     
      INTEGER CONFSUB(MAXSPROC,LMAXCONFIGS)
      INCLUDE 'config_subproc_map.inc'
      INTEGER NHEL(NEXTERNAL,NCOMB)
      INTEGER ISHEL(2)
      REAL*8 T,MATRIX1
      REAL*8 R,SUMHEL,TS(NCOMB)
      INTEGER I,IDEN
      INTEGER JC(NEXTERNAL),II
      REAL*8 HWGT, XTOT, XTRY, XREJ, XR, YFRAC(0:NCOMB)
      INTEGER NGOOD(2), IGOOD(NCOMB,2)
      INTEGER JHEL(2), J, JJ
      INTEGER THIS_NTRY(2)
      SAVE THIS_NTRY
      INTEGER NB_FAIL
      SAVE NB_FAIL
      DATA THIS_NTRY /0,0/
      DATA NB_FAIL /0/
      DOUBLE PRECISION GET_CHANNEL_CUT
      EXTERNAL GET_CHANNEL_CUT

C     
C     This is just to temporarily store the reference grid for
C      helicity of the DiscreteSampler so as to obtain its number of
C      entries with ref_helicity_grid%n_tot_entries
      TYPE(SAMPLEDDIMENSION) REF_HELICITY_GRID
C     
C     GLOBAL VARIABLES
C     
      LOGICAL INIT_MODE
      COMMON /TO_DETERMINE_ZERO_HEL/INIT_MODE
      DOUBLE PRECISION AMP2(MAXAMPS), JAMP2(0:MAXFLOW)
      COMMON/TO_AMPS/  AMP2,       JAMP2

      CHARACTER*101         HEL_BUFF
      COMMON/TO_HELICITY/  HEL_BUFF

      INTEGER NB_SPIN_STATE_IN(2)
      COMMON /NB_HEL_STATE/ NB_SPIN_STATE_IN

      INTEGER IMIRROR,IPROC
      COMMON/TO_MIRROR/ IMIRROR,IPROC

      DOUBLE PRECISION TMIN_FOR_CHANNEL
      INTEGER SDE_STRAT  ! 1 means standard single diagram enhancement strategy,
C     2 means approximation by the	denominator of the propagator
      COMMON/TO_CHANNEL_STRAT/TMIN_FOR_CHANNEL,	SDE_STRAT

      REAL*8 POL(2)
      COMMON/TO_POLARIZATION/ POL

      DOUBLE PRECISION SMALL_WIDTH_TREATMENT
      COMMON/NARROW_WIDTH/SMALL_WIDTH_TREATMENT

      INTEGER          ISUM_HEL
      LOGICAL                    MULTI_CHANNEL
      COMMON/TO_MATRIX/ISUM_HEL, MULTI_CHANNEL
      INTEGER MAPCONFIG(0:LMAXCONFIGS), ICONFIG
      COMMON/TO_MCONFIGS/MAPCONFIG, ICONFIG
      INTEGER SUBDIAG(MAXSPROC),IB(2)
      COMMON/TO_SUB_DIAG/SUBDIAG,IB
      DATA XTRY, XREJ /0,0/
      DATA NGOOD /0,0/
      DATA ISHEL/0,0/
      SAVE YFRAC, IGOOD, JHEL
      DATA (NHEL(I,   1),I=1,8) /-1, 1,-1, 1,-1, 1,-1, 1/
      DATA (NHEL(I,   2),I=1,8) /-1, 1,-1, 1,-1, 1,-1,-1/
      DATA (NHEL(I,   3),I=1,8) /-1, 1,-1, 1,-1, 1, 1, 1/
      DATA (NHEL(I,   4),I=1,8) /-1, 1,-1, 1,-1, 1, 1,-1/
      DATA (NHEL(I,   5),I=1,8) /-1, 1,-1, 1,-1,-1,-1, 1/
      DATA (NHEL(I,   6),I=1,8) /-1, 1,-1, 1,-1,-1,-1,-1/
      DATA (NHEL(I,   7),I=1,8) /-1, 1,-1, 1,-1,-1, 1, 1/
      DATA (NHEL(I,   8),I=1,8) /-1, 1,-1, 1,-1,-1, 1,-1/
      DATA (NHEL(I,   9),I=1,8) /-1, 1,-1, 1, 1, 1,-1, 1/
      DATA (NHEL(I,  10),I=1,8) /-1, 1,-1, 1, 1, 1,-1,-1/
      DATA (NHEL(I,  11),I=1,8) /-1, 1,-1, 1, 1, 1, 1, 1/
      DATA (NHEL(I,  12),I=1,8) /-1, 1,-1, 1, 1, 1, 1,-1/
      DATA (NHEL(I,  13),I=1,8) /-1, 1,-1, 1, 1,-1,-1, 1/
      DATA (NHEL(I,  14),I=1,8) /-1, 1,-1, 1, 1,-1,-1,-1/
      DATA (NHEL(I,  15),I=1,8) /-1, 1,-1, 1, 1,-1, 1, 1/
      DATA (NHEL(I,  16),I=1,8) /-1, 1,-1, 1, 1,-1, 1,-1/
      DATA (NHEL(I,  17),I=1,8) /-1, 1,-1,-1,-1, 1,-1, 1/
      DATA (NHEL(I,  18),I=1,8) /-1, 1,-1,-1,-1, 1,-1,-1/
      DATA (NHEL(I,  19),I=1,8) /-1, 1,-1,-1,-1, 1, 1, 1/
      DATA (NHEL(I,  20),I=1,8) /-1, 1,-1,-1,-1, 1, 1,-1/
      DATA (NHEL(I,  21),I=1,8) /-1, 1,-1,-1,-1,-1,-1, 1/
      DATA (NHEL(I,  22),I=1,8) /-1, 1,-1,-1,-1,-1,-1,-1/
      DATA (NHEL(I,  23),I=1,8) /-1, 1,-1,-1,-1,-1, 1, 1/
      DATA (NHEL(I,  24),I=1,8) /-1, 1,-1,-1,-1,-1, 1,-1/
      DATA (NHEL(I,  25),I=1,8) /-1, 1,-1,-1, 1, 1,-1, 1/
      DATA (NHEL(I,  26),I=1,8) /-1, 1,-1,-1, 1, 1,-1,-1/
      DATA (NHEL(I,  27),I=1,8) /-1, 1,-1,-1, 1, 1, 1, 1/
      DATA (NHEL(I,  28),I=1,8) /-1, 1,-1,-1, 1, 1, 1,-1/
      DATA (NHEL(I,  29),I=1,8) /-1, 1,-1,-1, 1,-1,-1, 1/
      DATA (NHEL(I,  30),I=1,8) /-1, 1,-1,-1, 1,-1,-1,-1/
      DATA (NHEL(I,  31),I=1,8) /-1, 1,-1,-1, 1,-1, 1, 1/
      DATA (NHEL(I,  32),I=1,8) /-1, 1,-1,-1, 1,-1, 1,-1/
      DATA (NHEL(I,  33),I=1,8) /-1, 1, 1, 1,-1, 1,-1, 1/
      DATA (NHEL(I,  34),I=1,8) /-1, 1, 1, 1,-1, 1,-1,-1/
      DATA (NHEL(I,  35),I=1,8) /-1, 1, 1, 1,-1, 1, 1, 1/
      DATA (NHEL(I,  36),I=1,8) /-1, 1, 1, 1,-1, 1, 1,-1/
      DATA (NHEL(I,  37),I=1,8) /-1, 1, 1, 1,-1,-1,-1, 1/
      DATA (NHEL(I,  38),I=1,8) /-1, 1, 1, 1,-1,-1,-1,-1/
      DATA (NHEL(I,  39),I=1,8) /-1, 1, 1, 1,-1,-1, 1, 1/
      DATA (NHEL(I,  40),I=1,8) /-1, 1, 1, 1,-1,-1, 1,-1/
      DATA (NHEL(I,  41),I=1,8) /-1, 1, 1, 1, 1, 1,-1, 1/
      DATA (NHEL(I,  42),I=1,8) /-1, 1, 1, 1, 1, 1,-1,-1/
      DATA (NHEL(I,  43),I=1,8) /-1, 1, 1, 1, 1, 1, 1, 1/
      DATA (NHEL(I,  44),I=1,8) /-1, 1, 1, 1, 1, 1, 1,-1/
      DATA (NHEL(I,  45),I=1,8) /-1, 1, 1, 1, 1,-1,-1, 1/
      DATA (NHEL(I,  46),I=1,8) /-1, 1, 1, 1, 1,-1,-1,-1/
      DATA (NHEL(I,  47),I=1,8) /-1, 1, 1, 1, 1,-1, 1, 1/
      DATA (NHEL(I,  48),I=1,8) /-1, 1, 1, 1, 1,-1, 1,-1/
      DATA (NHEL(I,  49),I=1,8) /-1, 1, 1,-1,-1, 1,-1, 1/
      DATA (NHEL(I,  50),I=1,8) /-1, 1, 1,-1,-1, 1,-1,-1/
      DATA (NHEL(I,  51),I=1,8) /-1, 1, 1,-1,-1, 1, 1, 1/
      DATA (NHEL(I,  52),I=1,8) /-1, 1, 1,-1,-1, 1, 1,-1/
      DATA (NHEL(I,  53),I=1,8) /-1, 1, 1,-1,-1,-1,-1, 1/
      DATA (NHEL(I,  54),I=1,8) /-1, 1, 1,-1,-1,-1,-1,-1/
      DATA (NHEL(I,  55),I=1,8) /-1, 1, 1,-1,-1,-1, 1, 1/
      DATA (NHEL(I,  56),I=1,8) /-1, 1, 1,-1,-1,-1, 1,-1/
      DATA (NHEL(I,  57),I=1,8) /-1, 1, 1,-1, 1, 1,-1, 1/
      DATA (NHEL(I,  58),I=1,8) /-1, 1, 1,-1, 1, 1,-1,-1/
      DATA (NHEL(I,  59),I=1,8) /-1, 1, 1,-1, 1, 1, 1, 1/
      DATA (NHEL(I,  60),I=1,8) /-1, 1, 1,-1, 1, 1, 1,-1/
      DATA (NHEL(I,  61),I=1,8) /-1, 1, 1,-1, 1,-1,-1, 1/
      DATA (NHEL(I,  62),I=1,8) /-1, 1, 1,-1, 1,-1,-1,-1/
      DATA (NHEL(I,  63),I=1,8) /-1, 1, 1,-1, 1,-1, 1, 1/
      DATA (NHEL(I,  64),I=1,8) /-1, 1, 1,-1, 1,-1, 1,-1/
      DATA (NHEL(I,  65),I=1,8) /-1,-1,-1, 1,-1, 1,-1, 1/
      DATA (NHEL(I,  66),I=1,8) /-1,-1,-1, 1,-1, 1,-1,-1/
      DATA (NHEL(I,  67),I=1,8) /-1,-1,-1, 1,-1, 1, 1, 1/
      DATA (NHEL(I,  68),I=1,8) /-1,-1,-1, 1,-1, 1, 1,-1/
      DATA (NHEL(I,  69),I=1,8) /-1,-1,-1, 1,-1,-1,-1, 1/
      DATA (NHEL(I,  70),I=1,8) /-1,-1,-1, 1,-1,-1,-1,-1/
      DATA (NHEL(I,  71),I=1,8) /-1,-1,-1, 1,-1,-1, 1, 1/
      DATA (NHEL(I,  72),I=1,8) /-1,-1,-1, 1,-1,-1, 1,-1/
      DATA (NHEL(I,  73),I=1,8) /-1,-1,-1, 1, 1, 1,-1, 1/
      DATA (NHEL(I,  74),I=1,8) /-1,-1,-1, 1, 1, 1,-1,-1/
      DATA (NHEL(I,  75),I=1,8) /-1,-1,-1, 1, 1, 1, 1, 1/
      DATA (NHEL(I,  76),I=1,8) /-1,-1,-1, 1, 1, 1, 1,-1/
      DATA (NHEL(I,  77),I=1,8) /-1,-1,-1, 1, 1,-1,-1, 1/
      DATA (NHEL(I,  78),I=1,8) /-1,-1,-1, 1, 1,-1,-1,-1/
      DATA (NHEL(I,  79),I=1,8) /-1,-1,-1, 1, 1,-1, 1, 1/
      DATA (NHEL(I,  80),I=1,8) /-1,-1,-1, 1, 1,-1, 1,-1/
      DATA (NHEL(I,  81),I=1,8) /-1,-1,-1,-1,-1, 1,-1, 1/
      DATA (NHEL(I,  82),I=1,8) /-1,-1,-1,-1,-1, 1,-1,-1/
      DATA (NHEL(I,  83),I=1,8) /-1,-1,-1,-1,-1, 1, 1, 1/
      DATA (NHEL(I,  84),I=1,8) /-1,-1,-1,-1,-1, 1, 1,-1/
      DATA (NHEL(I,  85),I=1,8) /-1,-1,-1,-1,-1,-1,-1, 1/
      DATA (NHEL(I,  86),I=1,8) /-1,-1,-1,-1,-1,-1,-1,-1/
      DATA (NHEL(I,  87),I=1,8) /-1,-1,-1,-1,-1,-1, 1, 1/
      DATA (NHEL(I,  88),I=1,8) /-1,-1,-1,-1,-1,-1, 1,-1/
      DATA (NHEL(I,  89),I=1,8) /-1,-1,-1,-1, 1, 1,-1, 1/
      DATA (NHEL(I,  90),I=1,8) /-1,-1,-1,-1, 1, 1,-1,-1/
      DATA (NHEL(I,  91),I=1,8) /-1,-1,-1,-1, 1, 1, 1, 1/
      DATA (NHEL(I,  92),I=1,8) /-1,-1,-1,-1, 1, 1, 1,-1/
      DATA (NHEL(I,  93),I=1,8) /-1,-1,-1,-1, 1,-1,-1, 1/
      DATA (NHEL(I,  94),I=1,8) /-1,-1,-1,-1, 1,-1,-1,-1/
      DATA (NHEL(I,  95),I=1,8) /-1,-1,-1,-1, 1,-1, 1, 1/
      DATA (NHEL(I,  96),I=1,8) /-1,-1,-1,-1, 1,-1, 1,-1/
      DATA (NHEL(I,  97),I=1,8) /-1,-1, 1, 1,-1, 1,-1, 1/
      DATA (NHEL(I,  98),I=1,8) /-1,-1, 1, 1,-1, 1,-1,-1/
      DATA (NHEL(I,  99),I=1,8) /-1,-1, 1, 1,-1, 1, 1, 1/
      DATA (NHEL(I, 100),I=1,8) /-1,-1, 1, 1,-1, 1, 1,-1/
      DATA (NHEL(I, 101),I=1,8) /-1,-1, 1, 1,-1,-1,-1, 1/
      DATA (NHEL(I, 102),I=1,8) /-1,-1, 1, 1,-1,-1,-1,-1/
      DATA (NHEL(I, 103),I=1,8) /-1,-1, 1, 1,-1,-1, 1, 1/
      DATA (NHEL(I, 104),I=1,8) /-1,-1, 1, 1,-1,-1, 1,-1/
      DATA (NHEL(I, 105),I=1,8) /-1,-1, 1, 1, 1, 1,-1, 1/
      DATA (NHEL(I, 106),I=1,8) /-1,-1, 1, 1, 1, 1,-1,-1/
      DATA (NHEL(I, 107),I=1,8) /-1,-1, 1, 1, 1, 1, 1, 1/
      DATA (NHEL(I, 108),I=1,8) /-1,-1, 1, 1, 1, 1, 1,-1/
      DATA (NHEL(I, 109),I=1,8) /-1,-1, 1, 1, 1,-1,-1, 1/
      DATA (NHEL(I, 110),I=1,8) /-1,-1, 1, 1, 1,-1,-1,-1/
      DATA (NHEL(I, 111),I=1,8) /-1,-1, 1, 1, 1,-1, 1, 1/
      DATA (NHEL(I, 112),I=1,8) /-1,-1, 1, 1, 1,-1, 1,-1/
      DATA (NHEL(I, 113),I=1,8) /-1,-1, 1,-1,-1, 1,-1, 1/
      DATA (NHEL(I, 114),I=1,8) /-1,-1, 1,-1,-1, 1,-1,-1/
      DATA (NHEL(I, 115),I=1,8) /-1,-1, 1,-1,-1, 1, 1, 1/
      DATA (NHEL(I, 116),I=1,8) /-1,-1, 1,-1,-1, 1, 1,-1/
      DATA (NHEL(I, 117),I=1,8) /-1,-1, 1,-1,-1,-1,-1, 1/
      DATA (NHEL(I, 118),I=1,8) /-1,-1, 1,-1,-1,-1,-1,-1/
      DATA (NHEL(I, 119),I=1,8) /-1,-1, 1,-1,-1,-1, 1, 1/
      DATA (NHEL(I, 120),I=1,8) /-1,-1, 1,-1,-1,-1, 1,-1/
      DATA (NHEL(I, 121),I=1,8) /-1,-1, 1,-1, 1, 1,-1, 1/
      DATA (NHEL(I, 122),I=1,8) /-1,-1, 1,-1, 1, 1,-1,-1/
      DATA (NHEL(I, 123),I=1,8) /-1,-1, 1,-1, 1, 1, 1, 1/
      DATA (NHEL(I, 124),I=1,8) /-1,-1, 1,-1, 1, 1, 1,-1/
      DATA (NHEL(I, 125),I=1,8) /-1,-1, 1,-1, 1,-1,-1, 1/
      DATA (NHEL(I, 126),I=1,8) /-1,-1, 1,-1, 1,-1,-1,-1/
      DATA (NHEL(I, 127),I=1,8) /-1,-1, 1,-1, 1,-1, 1, 1/
      DATA (NHEL(I, 128),I=1,8) /-1,-1, 1,-1, 1,-1, 1,-1/
      DATA (NHEL(I, 129),I=1,8) / 1, 1,-1, 1,-1, 1,-1, 1/
      DATA (NHEL(I, 130),I=1,8) / 1, 1,-1, 1,-1, 1,-1,-1/
      DATA (NHEL(I, 131),I=1,8) / 1, 1,-1, 1,-1, 1, 1, 1/
      DATA (NHEL(I, 132),I=1,8) / 1, 1,-1, 1,-1, 1, 1,-1/
      DATA (NHEL(I, 133),I=1,8) / 1, 1,-1, 1,-1,-1,-1, 1/
      DATA (NHEL(I, 134),I=1,8) / 1, 1,-1, 1,-1,-1,-1,-1/
      DATA (NHEL(I, 135),I=1,8) / 1, 1,-1, 1,-1,-1, 1, 1/
      DATA (NHEL(I, 136),I=1,8) / 1, 1,-1, 1,-1,-1, 1,-1/
      DATA (NHEL(I, 137),I=1,8) / 1, 1,-1, 1, 1, 1,-1, 1/
      DATA (NHEL(I, 138),I=1,8) / 1, 1,-1, 1, 1, 1,-1,-1/
      DATA (NHEL(I, 139),I=1,8) / 1, 1,-1, 1, 1, 1, 1, 1/
      DATA (NHEL(I, 140),I=1,8) / 1, 1,-1, 1, 1, 1, 1,-1/
      DATA (NHEL(I, 141),I=1,8) / 1, 1,-1, 1, 1,-1,-1, 1/
      DATA (NHEL(I, 142),I=1,8) / 1, 1,-1, 1, 1,-1,-1,-1/
      DATA (NHEL(I, 143),I=1,8) / 1, 1,-1, 1, 1,-1, 1, 1/
      DATA (NHEL(I, 144),I=1,8) / 1, 1,-1, 1, 1,-1, 1,-1/
      DATA (NHEL(I, 145),I=1,8) / 1, 1,-1,-1,-1, 1,-1, 1/
      DATA (NHEL(I, 146),I=1,8) / 1, 1,-1,-1,-1, 1,-1,-1/
      DATA (NHEL(I, 147),I=1,8) / 1, 1,-1,-1,-1, 1, 1, 1/
      DATA (NHEL(I, 148),I=1,8) / 1, 1,-1,-1,-1, 1, 1,-1/
      DATA (NHEL(I, 149),I=1,8) / 1, 1,-1,-1,-1,-1,-1, 1/
      DATA (NHEL(I, 150),I=1,8) / 1, 1,-1,-1,-1,-1,-1,-1/
      DATA (NHEL(I, 151),I=1,8) / 1, 1,-1,-1,-1,-1, 1, 1/
      DATA (NHEL(I, 152),I=1,8) / 1, 1,-1,-1,-1,-1, 1,-1/
      DATA (NHEL(I, 153),I=1,8) / 1, 1,-1,-1, 1, 1,-1, 1/
      DATA (NHEL(I, 154),I=1,8) / 1, 1,-1,-1, 1, 1,-1,-1/
      DATA (NHEL(I, 155),I=1,8) / 1, 1,-1,-1, 1, 1, 1, 1/
      DATA (NHEL(I, 156),I=1,8) / 1, 1,-1,-1, 1, 1, 1,-1/
      DATA (NHEL(I, 157),I=1,8) / 1, 1,-1,-1, 1,-1,-1, 1/
      DATA (NHEL(I, 158),I=1,8) / 1, 1,-1,-1, 1,-1,-1,-1/
      DATA (NHEL(I, 159),I=1,8) / 1, 1,-1,-1, 1,-1, 1, 1/
      DATA (NHEL(I, 160),I=1,8) / 1, 1,-1,-1, 1,-1, 1,-1/
      DATA (NHEL(I, 161),I=1,8) / 1, 1, 1, 1,-1, 1,-1, 1/
      DATA (NHEL(I, 162),I=1,8) / 1, 1, 1, 1,-1, 1,-1,-1/
      DATA (NHEL(I, 163),I=1,8) / 1, 1, 1, 1,-1, 1, 1, 1/
      DATA (NHEL(I, 164),I=1,8) / 1, 1, 1, 1,-1, 1, 1,-1/
      DATA (NHEL(I, 165),I=1,8) / 1, 1, 1, 1,-1,-1,-1, 1/
      DATA (NHEL(I, 166),I=1,8) / 1, 1, 1, 1,-1,-1,-1,-1/
      DATA (NHEL(I, 167),I=1,8) / 1, 1, 1, 1,-1,-1, 1, 1/
      DATA (NHEL(I, 168),I=1,8) / 1, 1, 1, 1,-1,-1, 1,-1/
      DATA (NHEL(I, 169),I=1,8) / 1, 1, 1, 1, 1, 1,-1, 1/
      DATA (NHEL(I, 170),I=1,8) / 1, 1, 1, 1, 1, 1,-1,-1/
      DATA (NHEL(I, 171),I=1,8) / 1, 1, 1, 1, 1, 1, 1, 1/
      DATA (NHEL(I, 172),I=1,8) / 1, 1, 1, 1, 1, 1, 1,-1/
      DATA (NHEL(I, 173),I=1,8) / 1, 1, 1, 1, 1,-1,-1, 1/
      DATA (NHEL(I, 174),I=1,8) / 1, 1, 1, 1, 1,-1,-1,-1/
      DATA (NHEL(I, 175),I=1,8) / 1, 1, 1, 1, 1,-1, 1, 1/
      DATA (NHEL(I, 176),I=1,8) / 1, 1, 1, 1, 1,-1, 1,-1/
      DATA (NHEL(I, 177),I=1,8) / 1, 1, 1,-1,-1, 1,-1, 1/
      DATA (NHEL(I, 178),I=1,8) / 1, 1, 1,-1,-1, 1,-1,-1/
      DATA (NHEL(I, 179),I=1,8) / 1, 1, 1,-1,-1, 1, 1, 1/
      DATA (NHEL(I, 180),I=1,8) / 1, 1, 1,-1,-1, 1, 1,-1/
      DATA (NHEL(I, 181),I=1,8) / 1, 1, 1,-1,-1,-1,-1, 1/
      DATA (NHEL(I, 182),I=1,8) / 1, 1, 1,-1,-1,-1,-1,-1/
      DATA (NHEL(I, 183),I=1,8) / 1, 1, 1,-1,-1,-1, 1, 1/
      DATA (NHEL(I, 184),I=1,8) / 1, 1, 1,-1,-1,-1, 1,-1/
      DATA (NHEL(I, 185),I=1,8) / 1, 1, 1,-1, 1, 1,-1, 1/
      DATA (NHEL(I, 186),I=1,8) / 1, 1, 1,-1, 1, 1,-1,-1/
      DATA (NHEL(I, 187),I=1,8) / 1, 1, 1,-1, 1, 1, 1, 1/
      DATA (NHEL(I, 188),I=1,8) / 1, 1, 1,-1, 1, 1, 1,-1/
      DATA (NHEL(I, 189),I=1,8) / 1, 1, 1,-1, 1,-1,-1, 1/
      DATA (NHEL(I, 190),I=1,8) / 1, 1, 1,-1, 1,-1,-1,-1/
      DATA (NHEL(I, 191),I=1,8) / 1, 1, 1,-1, 1,-1, 1, 1/
      DATA (NHEL(I, 192),I=1,8) / 1, 1, 1,-1, 1,-1, 1,-1/
      DATA (NHEL(I, 193),I=1,8) / 1,-1,-1, 1,-1, 1,-1, 1/
      DATA (NHEL(I, 194),I=1,8) / 1,-1,-1, 1,-1, 1,-1,-1/
      DATA (NHEL(I, 195),I=1,8) / 1,-1,-1, 1,-1, 1, 1, 1/
      DATA (NHEL(I, 196),I=1,8) / 1,-1,-1, 1,-1, 1, 1,-1/
      DATA (NHEL(I, 197),I=1,8) / 1,-1,-1, 1,-1,-1,-1, 1/
      DATA (NHEL(I, 198),I=1,8) / 1,-1,-1, 1,-1,-1,-1,-1/
      DATA (NHEL(I, 199),I=1,8) / 1,-1,-1, 1,-1,-1, 1, 1/
      DATA (NHEL(I, 200),I=1,8) / 1,-1,-1, 1,-1,-1, 1,-1/
      DATA (NHEL(I, 201),I=1,8) / 1,-1,-1, 1, 1, 1,-1, 1/
      DATA (NHEL(I, 202),I=1,8) / 1,-1,-1, 1, 1, 1,-1,-1/
      DATA (NHEL(I, 203),I=1,8) / 1,-1,-1, 1, 1, 1, 1, 1/
      DATA (NHEL(I, 204),I=1,8) / 1,-1,-1, 1, 1, 1, 1,-1/
      DATA (NHEL(I, 205),I=1,8) / 1,-1,-1, 1, 1,-1,-1, 1/
      DATA (NHEL(I, 206),I=1,8) / 1,-1,-1, 1, 1,-1,-1,-1/
      DATA (NHEL(I, 207),I=1,8) / 1,-1,-1, 1, 1,-1, 1, 1/
      DATA (NHEL(I, 208),I=1,8) / 1,-1,-1, 1, 1,-1, 1,-1/
      DATA (NHEL(I, 209),I=1,8) / 1,-1,-1,-1,-1, 1,-1, 1/
      DATA (NHEL(I, 210),I=1,8) / 1,-1,-1,-1,-1, 1,-1,-1/
      DATA (NHEL(I, 211),I=1,8) / 1,-1,-1,-1,-1, 1, 1, 1/
      DATA (NHEL(I, 212),I=1,8) / 1,-1,-1,-1,-1, 1, 1,-1/
      DATA (NHEL(I, 213),I=1,8) / 1,-1,-1,-1,-1,-1,-1, 1/
      DATA (NHEL(I, 214),I=1,8) / 1,-1,-1,-1,-1,-1,-1,-1/
      DATA (NHEL(I, 215),I=1,8) / 1,-1,-1,-1,-1,-1, 1, 1/
      DATA (NHEL(I, 216),I=1,8) / 1,-1,-1,-1,-1,-1, 1,-1/
      DATA (NHEL(I, 217),I=1,8) / 1,-1,-1,-1, 1, 1,-1, 1/
      DATA (NHEL(I, 218),I=1,8) / 1,-1,-1,-1, 1, 1,-1,-1/
      DATA (NHEL(I, 219),I=1,8) / 1,-1,-1,-1, 1, 1, 1, 1/
      DATA (NHEL(I, 220),I=1,8) / 1,-1,-1,-1, 1, 1, 1,-1/
      DATA (NHEL(I, 221),I=1,8) / 1,-1,-1,-1, 1,-1,-1, 1/
      DATA (NHEL(I, 222),I=1,8) / 1,-1,-1,-1, 1,-1,-1,-1/
      DATA (NHEL(I, 223),I=1,8) / 1,-1,-1,-1, 1,-1, 1, 1/
      DATA (NHEL(I, 224),I=1,8) / 1,-1,-1,-1, 1,-1, 1,-1/
      DATA (NHEL(I, 225),I=1,8) / 1,-1, 1, 1,-1, 1,-1, 1/
      DATA (NHEL(I, 226),I=1,8) / 1,-1, 1, 1,-1, 1,-1,-1/
      DATA (NHEL(I, 227),I=1,8) / 1,-1, 1, 1,-1, 1, 1, 1/
      DATA (NHEL(I, 228),I=1,8) / 1,-1, 1, 1,-1, 1, 1,-1/
      DATA (NHEL(I, 229),I=1,8) / 1,-1, 1, 1,-1,-1,-1, 1/
      DATA (NHEL(I, 230),I=1,8) / 1,-1, 1, 1,-1,-1,-1,-1/
      DATA (NHEL(I, 231),I=1,8) / 1,-1, 1, 1,-1,-1, 1, 1/
      DATA (NHEL(I, 232),I=1,8) / 1,-1, 1, 1,-1,-1, 1,-1/
      DATA (NHEL(I, 233),I=1,8) / 1,-1, 1, 1, 1, 1,-1, 1/
      DATA (NHEL(I, 234),I=1,8) / 1,-1, 1, 1, 1, 1,-1,-1/
      DATA (NHEL(I, 235),I=1,8) / 1,-1, 1, 1, 1, 1, 1, 1/
      DATA (NHEL(I, 236),I=1,8) / 1,-1, 1, 1, 1, 1, 1,-1/
      DATA (NHEL(I, 237),I=1,8) / 1,-1, 1, 1, 1,-1,-1, 1/
      DATA (NHEL(I, 238),I=1,8) / 1,-1, 1, 1, 1,-1,-1,-1/
      DATA (NHEL(I, 239),I=1,8) / 1,-1, 1, 1, 1,-1, 1, 1/
      DATA (NHEL(I, 240),I=1,8) / 1,-1, 1, 1, 1,-1, 1,-1/
      DATA (NHEL(I, 241),I=1,8) / 1,-1, 1,-1,-1, 1,-1, 1/
      DATA (NHEL(I, 242),I=1,8) / 1,-1, 1,-1,-1, 1,-1,-1/
      DATA (NHEL(I, 243),I=1,8) / 1,-1, 1,-1,-1, 1, 1, 1/
      DATA (NHEL(I, 244),I=1,8) / 1,-1, 1,-1,-1, 1, 1,-1/
      DATA (NHEL(I, 245),I=1,8) / 1,-1, 1,-1,-1,-1,-1, 1/
      DATA (NHEL(I, 246),I=1,8) / 1,-1, 1,-1,-1,-1,-1,-1/
      DATA (NHEL(I, 247),I=1,8) / 1,-1, 1,-1,-1,-1, 1, 1/
      DATA (NHEL(I, 248),I=1,8) / 1,-1, 1,-1,-1,-1, 1,-1/
      DATA (NHEL(I, 249),I=1,8) / 1,-1, 1,-1, 1, 1,-1, 1/
      DATA (NHEL(I, 250),I=1,8) / 1,-1, 1,-1, 1, 1,-1,-1/
      DATA (NHEL(I, 251),I=1,8) / 1,-1, 1,-1, 1, 1, 1, 1/
      DATA (NHEL(I, 252),I=1,8) / 1,-1, 1,-1, 1, 1, 1,-1/
      DATA (NHEL(I, 253),I=1,8) / 1,-1, 1,-1, 1,-1,-1, 1/
      DATA (NHEL(I, 254),I=1,8) / 1,-1, 1,-1, 1,-1,-1,-1/
      DATA (NHEL(I, 255),I=1,8) / 1,-1, 1,-1, 1,-1, 1, 1/
      DATA (NHEL(I, 256),I=1,8) / 1,-1, 1,-1, 1,-1, 1,-1/
      DATA IDEN/16/

C     To be able to control when the matrix<i> subroutine can add
C      entries to the grid for the MC over helicity configuration
      LOGICAL ALLOW_HELICITY_GRID_ENTRIES
      COMMON/TO_ALLOW_HELICITY_GRID_ENTRIES/ALLOW_HELICITY_GRID_ENTRIES

C     ----------
C     BEGIN CODE
C     ----------

      NTRY(IMIRROR)=NTRY(IMIRROR)+1
      THIS_NTRY(IMIRROR) = THIS_NTRY(IMIRROR)+1
      DO I=1,NEXTERNAL
        JC(I) = +1
      ENDDO

      IF (MULTI_CHANNEL) THEN
        DO I=1,NDIAGS
          AMP2(I)=0D0
        ENDDO
        JAMP2(0)=2
        DO I=1,INT(JAMP2(0))
          JAMP2(I)=0D0
        ENDDO
      ENDIF
      ANS = 0D0
      WRITE(HEL_BUFF,'(20I5)') (0,I=1,NEXTERNAL)
      DO I=1,NCOMB
        TS(I)=0D0
      ENDDO

        !   If the helicity grid status is 0, this means that it is not yet initialized.
        !   If HEL_PICKED==-1, this means that calls to other matrix<i> where in initialization mode as well for the helicity.
      IF ((ISHEL(IMIRROR).EQ.0.AND.ISUM_HEL.EQ.0)
     $ .OR.(DS_GET_DIM_STATUS('Helicity').EQ.0).OR.(HEL_PICKED.EQ.-1))
     $  THEN
        DO I=1,NCOMB
          IF (GOODHEL(I,IMIRROR) .OR. NTRY(IMIRROR)
     $     .LE.MAXTRIES.OR.(ISUM_HEL.NE.0).OR.THIS_NTRY(IMIRROR).LE.10)
     $      THEN
            T=MATRIX1(P ,NHEL(1,I),JC(1),I)
            DO JJ=1,NINCOMING
              IF(POL(JJ).NE.1D0.AND.NHEL(JJ,I).EQ.INT(SIGN(1D0,POL(JJ))
     $         )) THEN
                T=T*ABS(POL(JJ))*NB_SPIN_STATE_IN(JJ)/2D0  ! NB_SPIN_STATE(JJ)/2d0 is added for polarised beam
              ELSE IF(POL(JJ).NE.1D0)THEN
                T=T*(2D0-ABS(POL(JJ)))*NB_SPIN_STATE_IN(JJ)/2D0
              ENDIF
            ENDDO
            IF (ISUM_HEL.NE.0.AND.DS_GET_DIM_STATUS('Helicity')
     $       .EQ.0.AND.ALLOW_HELICITY_GRID_ENTRIES) THEN
              CALL DS_ADD_ENTRY('Helicity',I,T)
            ENDIF
            ANS=ANS+DABS(T)
            TS(I)=T
          ENDIF
        ENDDO
        IF(NTRY(IMIRROR).EQ.(MAXTRIES+1)) THEN
          CALL RESET_CUMULATIVE_VARIABLE()  ! avoid biais of the initialization
        ENDIF
        IF (ISUM_HEL.NE.0) THEN
            !         We set HEL_PICKED to -1 here so that later on, the call to DS_add_point in dsample.f does not add anything to the grid since it was already done here.
          HEL_PICKED = -1
            !         For safety, hardset the helicity sampling jacobian to 0.0d0 to make sure it is not .
          HEL_JACOBIAN   = 1.0D0
            !         We don't want to re-update the helicity grid if it was already updated by another matrix<i>, so we make sure that the reference grid is empty.
          REF_HELICITY_GRID = DS_GET_DIMENSION(REF_GRID,'Helicity')
          IF((DS_GET_DIM_STATUS('Helicity').EQ.1)
     $     .AND.(REF_HELICITY_GRID%N_TOT_ENTRIES.EQ.0)) THEN
              !           If we finished the initialization we can update the grid so as to start sampling over it.
              !           However the grid will now be filled by dsample with different kind of weights (including pdf, flux, etc...) so by setting the grid_mode of the reference grid to 'initialization' we make sure it will be overwritten (as opposed to 'combined') by the running grid at the next update.
            CALL DS_UPDATE_GRID('Helicity')
            CALL DS_SET_GRID_MODE('Helicity','init')
          ENDIF
        ELSE
          JHEL(IMIRROR) = 1
          IF(NTRY(IMIRROR).LE.MAXTRIES.OR.THIS_NTRY(IMIRROR).LE.10)THEN
            DO I=1,NCOMB
              IF(INIT_MODE) THEN
                IF (DABS(TS(I)).GT.ANS*LIMHEL/NCOMB) THEN
                  PRINT *, 'Matrix Element/Good Helicity: 1 ', I,
     $              'IMIRROR', IMIRROR
                ENDIF
              ELSE IF (.NOT.GOODHEL(I,IMIRROR) .AND. (DABS(TS(I))
     $         .GT.ANS*LIMHEL/NCOMB)) THEN
                GOODHEL(I,IMIRROR)=.TRUE.
                NGOOD(IMIRROR) = NGOOD(IMIRROR) +1
                IGOOD(NGOOD(IMIRROR),IMIRROR) = I
                PRINT *,'Added good helicity ',I,TS(I)*NCOMB/ANS,' in'
     $           //' event ',NTRY(IMIRROR), 'local:',THIS_NTRY(IMIRROR)
              ENDIF
            ENDDO
          ENDIF
          IF(NTRY(IMIRROR).EQ.MAXTRIES)THEN
            ISHEL(IMIRROR)=MIN(ISUM_HEL,NGOOD(IMIRROR))
          ENDIF
        ENDIF
      ELSE IF (.NOT.INIT_MODE) THEN  ! random helicity 
C       The helicity configuration was chosen already by genps and put
C        in a common block defined in genps.inc.
        I = HEL_PICKED

        T=MATRIX1(P ,NHEL(1,I),JC(1),I)

        DO JJ=1,NINCOMING
          IF(POL(JJ).NE.1D0.AND.NHEL(JJ,I).EQ.INT(SIGN(1D0,POL(JJ))))
     $      THEN
            T=T*ABS(POL(JJ))
          ELSE IF(POL(JJ).NE.1D0)THEN
            T=T*(2D0-ABS(POL(JJ)))
          ENDIF
        ENDDO
C       Always one helicity at a time
        ANS = T
C       Include the Jacobian from helicity sampling
        ANS = ANS * HEL_JACOBIAN

        WRITE(HEL_BUFF,'(20i5)')(NHEL(II,I),II=1,NEXTERNAL)
      ELSE
        ANS = 1D0
        RETURN
      ENDIF
      IF (ANS.NE.0D0.AND.(ISUM_HEL .NE. 1.OR.HEL_PICKED.EQ.-1)) THEN
        CALL RANMAR(R)
        SUMHEL=0D0
        DO I=1,NCOMB
          SUMHEL=SUMHEL+DABS(TS(I))/ANS
          IF(R.LT.SUMHEL)THEN
            WRITE(HEL_BUFF,'(20i5)')(NHEL(II,I),II=1,NEXTERNAL)
C           Set right sign for ANS, based on sign of chosen helicity
            ANS=DSIGN(ANS,TS(I))
            GOTO 10
          ENDIF
        ENDDO
 10     CONTINUE
      ENDIF
      IF (MULTI_CHANNEL) THEN
        XTOT=0D0
        DO I=1,LMAXCONFIGS
          J = CONFSUB(1, I)
          IF (J.NE.0) THEN
            IF(SDE_STRAT.EQ.1) THEN
              AMP2(J) = AMP2(J) * GET_CHANNEL_CUT(P, I)
              XTOT=XTOT+AMP2(J)
            ELSE
              AMP2(J) = GET_CHANNEL_CUT(P, I)
              XTOT=XTOT+AMP2(J)
            ENDIF
          ENDIF
        ENDDO
        IF (XTOT.NE.0D0) THEN
          ANS=ANS*AMP2(SUBDIAG(1))/XTOT
        ELSE IF(ANS.NE.0D0) THEN
          IF(NB_FAIL.GE.10)THEN
            WRITE(*,*) 'Problem in the multi-channeling. All amp2 are'
     $       //' zero but not the total matrix-element'

            STOP 1
          ELSE
            NB_FAIL = NB_FAIL +1
          ENDIF
        ENDIF
      ENDIF
      ANS=ANS/DBLE(IDEN)
      END


      REAL*8 FUNCTION MATRIX1(P,NHEL,IC, IHEL)
C     
C     Generated by MadGraph5_aMC@NLO v. 3.2.0, 2021-08-22
C     By the MadGraph5_aMC@NLO Development Team
C     Visit launchpad.net/madgraph5 and amcatnlo.web.cern.ch
C     
C     Returns amplitude squared summed/avg over colors
C     for the point with external lines W(0:6,NEXTERNAL)
C     
C     Process: mu+ mu- > b b~ b b~ vm vm~ WEIGHTED<=10 @1
C     
      IMPLICIT NONE
C     
C     CONSTANTS
C     
      INTEGER    NGRAPHS
      PARAMETER (NGRAPHS=220)
      INTEGER                 NCOMB
      PARAMETER (             NCOMB=256)
      INCLUDE 'genps.inc'
      INCLUDE 'nexternal.inc'
      INCLUDE 'maxamps.inc'
      INTEGER    NWAVEFUNCS,     NCOLOR
      PARAMETER (NWAVEFUNCS=38, NCOLOR=2)
      REAL*8     ZERO
      PARAMETER (ZERO=0D0)
      COMPLEX*16 IMAG1
      PARAMETER (IMAG1=(0D0,1D0))
      INTEGER NAMPSO, NSQAMPSO
      PARAMETER (NAMPSO=1, NSQAMPSO=1)
      LOGICAL CHOSEN_SO_CONFIGS(NSQAMPSO)
      DATA CHOSEN_SO_CONFIGS/.TRUE./
      SAVE CHOSEN_SO_CONFIGS
C     
C     ARGUMENTS 
C     
      REAL*8 P(0:3,NEXTERNAL)
      INTEGER NHEL(NEXTERNAL), IC(NEXTERNAL)
      INTEGER IHEL
C     
C     LOCAL VARIABLES 
C     
      INTEGER I,J,M,N
      COMPLEX*16 ZTEMP, TMP_JAMP(218)
      REAL*8 CF(NCOLOR,NCOLOR)
      COMPLEX*16 AMP(NGRAPHS), JAMP(NCOLOR,NAMPSO)
      COMPLEX*16 W(6,NWAVEFUNCS)
C     Needed for v4 models
      COMPLEX*16 DUM0,DUM1
      DATA DUM0, DUM1/(0D0, 0D0), (1D0, 0D0)/

      DOUBLE PRECISION FK_MDL_WH
      DOUBLE PRECISION FK_MDL_WW
      DOUBLE PRECISION FK_ZERO
      DOUBLE PRECISION FK_MDL_WZ
      DOUBLE PRECISION FK_MDL_WT
      SAVE FK_MDL_WH
      SAVE FK_MDL_WW
      SAVE FK_ZERO
      SAVE FK_MDL_WZ
      SAVE FK_MDL_WT

      LOGICAL FIRST
      DATA FIRST /.TRUE./
      SAVE FIRST
C     
C     FUNCTION
C     
      INTEGER SQSOINDEX1
C     
C     GLOBAL VARIABLES
C     
      DOUBLE PRECISION AMP2(MAXAMPS), JAMP2(0:MAXFLOW)
      COMMON/TO_AMPS/  AMP2,       JAMP2
      INCLUDE 'coupl.inc'

      DOUBLE PRECISION SMALL_WIDTH_TREATMENT
      COMMON/NARROW_WIDTH/SMALL_WIDTH_TREATMENT

      LOGICAL INIT_MODE
      COMMON/TO_DETERMINE_ZERO_HEL/INIT_MODE

      LOGICAL ZEROAMP_1(NCOMB,NGRAPHS)
      COMMON/TO_ZEROAMP_1/ZEROAMP_1

      DOUBLE PRECISION TMIN_FOR_CHANNEL
      INTEGER SDE_STRAT  ! 1 means standard single diagram enhancement strategy,
C     2 means approximation by the	denominator of the propagator
      COMMON/TO_CHANNEL_STRAT/TMIN_FOR_CHANNEL,	SDE_STRAT

C     
C     COLOR DATA
C     
      DATA (CF(I,  1),I=  1,  2) /9.000000000000000D+00
     $ ,3.000000000000000D+00/
C     1 T(3,4) T(5,6)
      DATA (CF(I,  2),I=  1,  2) /3.000000000000000D+00
     $ ,9.000000000000000D+00/
C     1 T(3,6) T(5,4)
C     ----------
C     BEGIN CODE
C     ----------
      IF (FIRST) THEN
        FIRST=.FALSE.
        IF(ZERO.NE.0D0) FK_ZERO = SIGN(MAX(ABS(ZERO), ABS(ZERO
     $   *SMALL_WIDTH_TREATMENT)), ZERO)
        IF(ZERO.NE.0D0) FK_ZERO = SIGN(MAX(ABS(ZERO), ABS(MDL_MB
     $   *SMALL_WIDTH_TREATMENT)), ZERO)
        IF(MDL_WH.NE.0D0) FK_MDL_WH = SIGN(MAX(ABS(MDL_WH), ABS(MDL_MH
     $   *SMALL_WIDTH_TREATMENT)), MDL_WH)
        IF(MDL_WT.NE.0D0) FK_MDL_WT = SIGN(MAX(ABS(MDL_WT), ABS(MDL_MT
     $   *SMALL_WIDTH_TREATMENT)), MDL_WT)
        IF(MDL_WW.NE.0D0) FK_MDL_WW = SIGN(MAX(ABS(MDL_WW), ABS(MDL_MW
     $   *SMALL_WIDTH_TREATMENT)), MDL_WW)
        IF(MDL_WZ.NE.0D0) FK_MDL_WZ = SIGN(MAX(ABS(MDL_WZ), ABS(MDL_MZ
     $   *SMALL_WIDTH_TREATMENT)), MDL_WZ)

        IF(INIT_MODE) THEN
          ZEROAMP_1(:,:) = .TRUE.
        ENDIF
      ENDIF


      CALL OXXXXX(P(0,1),ZERO,NHEL(1),-1*IC(1),W(1,1))
      CALL IXXXXX(P(0,2),ZERO,NHEL(2),+1*IC(2),W(1,2))
      CALL OXXXXX(P(0,3),MDL_MB,NHEL(3),+1*IC(3),W(1,3))
      CALL IXXXXX(P(0,4),MDL_MB,NHEL(4),-1*IC(4),W(1,4))
      CALL OXXXXX(P(0,5),MDL_MB,NHEL(5),+1*IC(5),W(1,5))
      CALL IXXXXX(P(0,6),MDL_MB,NHEL(6),-1*IC(6),W(1,6))
      CALL OXXXXX(P(0,7),ZERO,NHEL(7),+1*IC(7),W(1,7))
      CALL IXXXXX(P(0,8),ZERO,NHEL(8),-1*IC(8),W(1,8))
      CALL FFV2_4_3(W(1,2),W(1,1),GC_50,GC_59,MDL_MZ, FK_MDL_WZ,W(1,9))
      CALL FFV1P0_3(W(1,4),W(1,3),GC_11,ZERO, FK_ZERO,W(1,10))
      CALL FFV2_1(W(1,7),W(1,9),GC_62,ZERO, FK_ZERO,W(1,11))
      CALL FFV1_1(W(1,5),W(1,10),GC_11,MDL_MB, FK_ZERO,W(1,12))
      CALL FFV2_3(W(1,8),W(1,11),GC_62,MDL_MZ, FK_MDL_WZ,W(1,13))
C     Amplitude(s) for diagram number 1
      CALL FFV2_3_0(W(1,6),W(1,12),W(1,13),GC_50,GC_58,AMP(1))
      CALL FFV1_2(W(1,6),W(1,10),GC_11,MDL_MB, FK_ZERO,W(1,11))
C     Amplitude(s) for diagram number 2
      CALL FFV2_3_0(W(1,11),W(1,5),W(1,13),GC_50,GC_58,AMP(2))
      CALL FFV2_2(W(1,8),W(1,9),GC_62,ZERO, FK_ZERO,W(1,14))
      CALL FFV2_3(W(1,14),W(1,7),GC_62,MDL_MZ, FK_MDL_WZ,W(1,15))
C     Amplitude(s) for diagram number 3
      CALL FFV2_3_0(W(1,6),W(1,12),W(1,15),GC_50,GC_58,AMP(3))
C     Amplitude(s) for diagram number 4
      CALL FFV2_3_0(W(1,11),W(1,5),W(1,15),GC_50,GC_58,AMP(4))
      CALL FFV1P0_3(W(1,2),W(1,1),GC_3,ZERO, FK_ZERO,W(1,14))
      CALL FFV2_3(W(1,8),W(1,7),GC_62,MDL_MZ, FK_MDL_WZ,W(1,16))
      CALL FFV1_1(W(1,5),W(1,14),GC_1,MDL_MB, FK_ZERO,W(1,17))
C     Amplitude(s) for diagram number 5
      CALL FFV2_3_0(W(1,11),W(1,17),W(1,16),GC_50,GC_58,AMP(5))
      CALL FFV2_3_2(W(1,6),W(1,16),GC_50,GC_58,MDL_MB, FK_ZERO,W(1,18))
C     Amplitude(s) for diagram number 6
      CALL FFV1_0(W(1,18),W(1,17),W(1,10),GC_11,AMP(6))
      CALL FFV1_2(W(1,6),W(1,14),GC_1,MDL_MB, FK_ZERO,W(1,19))
C     Amplitude(s) for diagram number 7
      CALL FFV2_3_0(W(1,19),W(1,12),W(1,16),GC_50,GC_58,AMP(7))
      CALL FFV2_3_1(W(1,5),W(1,16),GC_50,GC_58,MDL_MB, FK_ZERO,W(1,20))
C     Amplitude(s) for diagram number 8
      CALL FFV1_0(W(1,19),W(1,20),W(1,10),GC_11,AMP(8))
C     Amplitude(s) for diagram number 9
      CALL FFV1_0(W(1,18),W(1,12),W(1,14),GC_1,AMP(9))
C     Amplitude(s) for diagram number 10
      CALL FFV1_0(W(1,11),W(1,20),W(1,14),GC_1,AMP(10))
      CALL FFV2_3_1(W(1,5),W(1,9),GC_50,GC_58,MDL_MB, FK_ZERO,W(1,21))
C     Amplitude(s) for diagram number 11
      CALL FFV2_3_0(W(1,11),W(1,21),W(1,16),GC_50,GC_58,AMP(11))
C     Amplitude(s) for diagram number 12
      CALL FFV1_0(W(1,18),W(1,21),W(1,10),GC_11,AMP(12))
      CALL FFV2_3_2(W(1,6),W(1,9),GC_50,GC_58,MDL_MB, FK_ZERO,W(1,22))
C     Amplitude(s) for diagram number 13
      CALL FFV2_3_0(W(1,22),W(1,12),W(1,16),GC_50,GC_58,AMP(13))
C     Amplitude(s) for diagram number 14
      CALL FFV1_0(W(1,22),W(1,20),W(1,10),GC_11,AMP(14))
      CALL VVS1_3(W(1,9),W(1,16),GC_81,MDL_MH, FK_MDL_WH,W(1,23))
C     Amplitude(s) for diagram number 15
      CALL FFS4_0(W(1,6),W(1,12),W(1,23),GC_83,AMP(15))
C     Amplitude(s) for diagram number 16
      CALL FFS4_0(W(1,11),W(1,5),W(1,23),GC_83,AMP(16))
C     Amplitude(s) for diagram number 17
      CALL FFV2_3_0(W(1,18),W(1,12),W(1,9),GC_50,GC_58,AMP(17))
C     Amplitude(s) for diagram number 18
      CALL FFV2_3_0(W(1,11),W(1,20),W(1,9),GC_50,GC_58,AMP(18))
      CALL FFV1P0_3(W(1,6),W(1,3),GC_11,ZERO, FK_ZERO,W(1,24))
      CALL FFV1_2(W(1,4),W(1,24),GC_11,MDL_MB, FK_ZERO,W(1,25))
C     Amplitude(s) for diagram number 19
      CALL FFV2_3_0(W(1,25),W(1,5),W(1,13),GC_50,GC_58,AMP(19))
      CALL FFV1_1(W(1,5),W(1,24),GC_11,MDL_MB, FK_ZERO,W(1,26))
C     Amplitude(s) for diagram number 20
      CALL FFV2_3_0(W(1,4),W(1,26),W(1,13),GC_50,GC_58,AMP(20))
C     Amplitude(s) for diagram number 21
      CALL FFV2_3_0(W(1,25),W(1,5),W(1,15),GC_50,GC_58,AMP(21))
C     Amplitude(s) for diagram number 22
      CALL FFV2_3_0(W(1,4),W(1,26),W(1,15),GC_50,GC_58,AMP(22))
      CALL FFV1_2(W(1,4),W(1,14),GC_1,MDL_MB, FK_ZERO,W(1,27))
C     Amplitude(s) for diagram number 23
      CALL FFV2_3_0(W(1,27),W(1,26),W(1,16),GC_50,GC_58,AMP(23))
C     Amplitude(s) for diagram number 24
      CALL FFV1_0(W(1,27),W(1,20),W(1,24),GC_11,AMP(24))
C     Amplitude(s) for diagram number 25
      CALL FFV2_3_0(W(1,25),W(1,17),W(1,16),GC_50,GC_58,AMP(25))
      CALL FFV2_3_2(W(1,4),W(1,16),GC_50,GC_58,MDL_MB, FK_ZERO,W(1,28))
C     Amplitude(s) for diagram number 26
      CALL FFV1_0(W(1,28),W(1,17),W(1,24),GC_11,AMP(26))
C     Amplitude(s) for diagram number 27
      CALL FFV1_0(W(1,25),W(1,20),W(1,14),GC_1,AMP(27))
C     Amplitude(s) for diagram number 28
      CALL FFV1_0(W(1,28),W(1,26),W(1,14),GC_1,AMP(28))
      CALL FFV2_3_2(W(1,4),W(1,9),GC_50,GC_58,MDL_MB, FK_ZERO,W(1,29))
C     Amplitude(s) for diagram number 29
      CALL FFV2_3_0(W(1,29),W(1,26),W(1,16),GC_50,GC_58,AMP(29))
C     Amplitude(s) for diagram number 30
      CALL FFV1_0(W(1,29),W(1,20),W(1,24),GC_11,AMP(30))
C     Amplitude(s) for diagram number 31
      CALL FFV2_3_0(W(1,25),W(1,21),W(1,16),GC_50,GC_58,AMP(31))
C     Amplitude(s) for diagram number 32
      CALL FFV1_0(W(1,28),W(1,21),W(1,24),GC_11,AMP(32))
C     Amplitude(s) for diagram number 33
      CALL FFS4_0(W(1,25),W(1,5),W(1,23),GC_83,AMP(33))
C     Amplitude(s) for diagram number 34
      CALL FFS4_0(W(1,4),W(1,26),W(1,23),GC_83,AMP(34))
C     Amplitude(s) for diagram number 35
      CALL FFV2_3_0(W(1,25),W(1,20),W(1,9),GC_50,GC_58,AMP(35))
C     Amplitude(s) for diagram number 36
      CALL FFV2_3_0(W(1,28),W(1,26),W(1,9),GC_50,GC_58,AMP(36))
      CALL FFV1P0_3(W(1,4),W(1,5),GC_11,ZERO, FK_ZERO,W(1,30))
      CALL FFV1_1(W(1,3),W(1,30),GC_11,MDL_MB, FK_ZERO,W(1,31))
C     Amplitude(s) for diagram number 37
      CALL FFV2_3_0(W(1,6),W(1,31),W(1,13),GC_50,GC_58,AMP(37))
      CALL FFV1_2(W(1,6),W(1,30),GC_11,MDL_MB, FK_ZERO,W(1,32))
C     Amplitude(s) for diagram number 38
      CALL FFV2_3_0(W(1,32),W(1,3),W(1,13),GC_50,GC_58,AMP(38))
C     Amplitude(s) for diagram number 39
      CALL FFV2_3_0(W(1,6),W(1,31),W(1,15),GC_50,GC_58,AMP(39))
C     Amplitude(s) for diagram number 40
      CALL FFV2_3_0(W(1,32),W(1,3),W(1,15),GC_50,GC_58,AMP(40))
      CALL FFV1_1(W(1,3),W(1,14),GC_1,MDL_MB, FK_ZERO,W(1,33))
C     Amplitude(s) for diagram number 41
      CALL FFV2_3_0(W(1,32),W(1,33),W(1,16),GC_50,GC_58,AMP(41))
C     Amplitude(s) for diagram number 42
      CALL FFV1_0(W(1,18),W(1,33),W(1,30),GC_11,AMP(42))
C     Amplitude(s) for diagram number 43
      CALL FFV2_3_0(W(1,19),W(1,31),W(1,16),GC_50,GC_58,AMP(43))
      CALL FFV2_3_1(W(1,3),W(1,16),GC_50,GC_58,MDL_MB, FK_ZERO,W(1,34))
C     Amplitude(s) for diagram number 44
      CALL FFV1_0(W(1,19),W(1,34),W(1,30),GC_11,AMP(44))
C     Amplitude(s) for diagram number 45
      CALL FFV1_0(W(1,18),W(1,31),W(1,14),GC_1,AMP(45))
C     Amplitude(s) for diagram number 46
      CALL FFV1_0(W(1,32),W(1,34),W(1,14),GC_1,AMP(46))
      CALL FFV2_3_1(W(1,3),W(1,9),GC_50,GC_58,MDL_MB, FK_ZERO,W(1,35))
C     Amplitude(s) for diagram number 47
      CALL FFV2_3_0(W(1,32),W(1,35),W(1,16),GC_50,GC_58,AMP(47))
C     Amplitude(s) for diagram number 48
      CALL FFV1_0(W(1,18),W(1,35),W(1,30),GC_11,AMP(48))
C     Amplitude(s) for diagram number 49
      CALL FFV2_3_0(W(1,22),W(1,31),W(1,16),GC_50,GC_58,AMP(49))
C     Amplitude(s) for diagram number 50
      CALL FFV1_0(W(1,22),W(1,34),W(1,30),GC_11,AMP(50))
C     Amplitude(s) for diagram number 51
      CALL FFS4_0(W(1,6),W(1,31),W(1,23),GC_83,AMP(51))
C     Amplitude(s) for diagram number 52
      CALL FFS4_0(W(1,32),W(1,3),W(1,23),GC_83,AMP(52))
C     Amplitude(s) for diagram number 53
      CALL FFV2_3_0(W(1,18),W(1,31),W(1,9),GC_50,GC_58,AMP(53))
C     Amplitude(s) for diagram number 54
      CALL FFV2_3_0(W(1,32),W(1,34),W(1,9),GC_50,GC_58,AMP(54))
      CALL FFV1P0_3(W(1,6),W(1,5),GC_11,ZERO, FK_ZERO,W(1,36))
      CALL FFV1_1(W(1,3),W(1,36),GC_11,MDL_MB, FK_ZERO,W(1,37))
C     Amplitude(s) for diagram number 55
      CALL FFV2_3_0(W(1,4),W(1,37),W(1,13),GC_50,GC_58,AMP(55))
      CALL FFV1_2(W(1,4),W(1,36),GC_11,MDL_MB, FK_ZERO,W(1,38))
C     Amplitude(s) for diagram number 56
      CALL FFV2_3_0(W(1,38),W(1,3),W(1,13),GC_50,GC_58,AMP(56))
C     Amplitude(s) for diagram number 57
      CALL FFV2_3_0(W(1,4),W(1,37),W(1,15),GC_50,GC_58,AMP(57))
C     Amplitude(s) for diagram number 58
      CALL FFV2_3_0(W(1,38),W(1,3),W(1,15),GC_50,GC_58,AMP(58))
C     Amplitude(s) for diagram number 59
      CALL FFV2_3_0(W(1,38),W(1,33),W(1,16),GC_50,GC_58,AMP(59))
C     Amplitude(s) for diagram number 60
      CALL FFV1_0(W(1,28),W(1,33),W(1,36),GC_11,AMP(60))
C     Amplitude(s) for diagram number 61
      CALL FFV2_3_0(W(1,27),W(1,37),W(1,16),GC_50,GC_58,AMP(61))
C     Amplitude(s) for diagram number 62
      CALL FFV1_0(W(1,27),W(1,34),W(1,36),GC_11,AMP(62))
C     Amplitude(s) for diagram number 63
      CALL FFV1_0(W(1,28),W(1,37),W(1,14),GC_1,AMP(63))
C     Amplitude(s) for diagram number 64
      CALL FFV1_0(W(1,38),W(1,34),W(1,14),GC_1,AMP(64))
C     Amplitude(s) for diagram number 65
      CALL FFV2_3_0(W(1,38),W(1,35),W(1,16),GC_50,GC_58,AMP(65))
C     Amplitude(s) for diagram number 66
      CALL FFV1_0(W(1,28),W(1,35),W(1,36),GC_11,AMP(66))
C     Amplitude(s) for diagram number 67
      CALL FFV2_3_0(W(1,29),W(1,37),W(1,16),GC_50,GC_58,AMP(67))
C     Amplitude(s) for diagram number 68
      CALL FFV1_0(W(1,29),W(1,34),W(1,36),GC_11,AMP(68))
C     Amplitude(s) for diagram number 69
      CALL FFS4_0(W(1,4),W(1,37),W(1,23),GC_83,AMP(69))
C     Amplitude(s) for diagram number 70
      CALL FFS4_0(W(1,38),W(1,3),W(1,23),GC_83,AMP(70))
C     Amplitude(s) for diagram number 71
      CALL FFV2_3_0(W(1,28),W(1,37),W(1,9),GC_50,GC_58,AMP(71))
C     Amplitude(s) for diagram number 72
      CALL FFV2_3_0(W(1,38),W(1,34),W(1,9),GC_50,GC_58,AMP(72))
      CALL FFV1P0_3(W(1,6),W(1,33),GC_11,ZERO, FK_ZERO,W(1,9))
C     Amplitude(s) for diagram number 73
      CALL FFV1_0(W(1,28),W(1,5),W(1,9),GC_11,AMP(73))
      CALL FFV1P0_3(W(1,4),W(1,33),GC_11,ZERO, FK_ZERO,W(1,23))
C     Amplitude(s) for diagram number 74
      CALL FFV1_0(W(1,6),W(1,20),W(1,23),GC_11,AMP(74))
C     Amplitude(s) for diagram number 75
      CALL FFV1_0(W(1,4),W(1,20),W(1,9),GC_11,AMP(75))
C     Amplitude(s) for diagram number 76
      CALL FFV1_0(W(1,18),W(1,5),W(1,23),GC_11,AMP(76))
      CALL FFV1P0_3(W(1,27),W(1,5),GC_11,ZERO, FK_ZERO,W(1,23))
C     Amplitude(s) for diagram number 77
      CALL FFV1_0(W(1,6),W(1,34),W(1,23),GC_11,AMP(77))
      CALL FFV1P0_3(W(1,27),W(1,3),GC_11,ZERO, FK_ZERO,W(1,9))
C     Amplitude(s) for diagram number 78
      CALL FFV1_0(W(1,6),W(1,20),W(1,9),GC_11,AMP(78))
C     Amplitude(s) for diagram number 79
      CALL FFV1_0(W(1,18),W(1,5),W(1,9),GC_11,AMP(79))
C     Amplitude(s) for diagram number 80
      CALL FFV1_0(W(1,18),W(1,3),W(1,23),GC_11,AMP(80))
      CALL FFV1P0_3(W(1,4),W(1,17),GC_11,ZERO, FK_ZERO,W(1,23))
C     Amplitude(s) for diagram number 81
      CALL FFV1_0(W(1,6),W(1,34),W(1,23),GC_11,AMP(81))
      CALL FFV1P0_3(W(1,6),W(1,17),GC_11,ZERO, FK_ZERO,W(1,9))
C     Amplitude(s) for diagram number 82
      CALL FFV1_0(W(1,4),W(1,34),W(1,9),GC_11,AMP(82))
C     Amplitude(s) for diagram number 83
      CALL FFV1_0(W(1,28),W(1,3),W(1,9),GC_11,AMP(83))
C     Amplitude(s) for diagram number 84
      CALL FFV1_0(W(1,18),W(1,3),W(1,23),GC_11,AMP(84))
      CALL FFV1P0_3(W(1,19),W(1,5),GC_11,ZERO, FK_ZERO,W(1,23))
C     Amplitude(s) for diagram number 85
      CALL FFV1_0(W(1,4),W(1,34),W(1,23),GC_11,AMP(85))
      CALL FFV1P0_3(W(1,19),W(1,3),GC_11,ZERO, FK_ZERO,W(1,9))
C     Amplitude(s) for diagram number 86
      CALL FFV1_0(W(1,28),W(1,5),W(1,9),GC_11,AMP(86))
C     Amplitude(s) for diagram number 87
      CALL FFV1_0(W(1,28),W(1,3),W(1,23),GC_11,AMP(87))
C     Amplitude(s) for diagram number 88
      CALL FFV1_0(W(1,4),W(1,20),W(1,9),GC_11,AMP(88))
      CALL FFV1P0_3(W(1,6),W(1,35),GC_11,ZERO, FK_ZERO,W(1,9))
C     Amplitude(s) for diagram number 89
      CALL FFV1_0(W(1,28),W(1,5),W(1,9),GC_11,AMP(89))
      CALL FFV1P0_3(W(1,4),W(1,35),GC_11,ZERO, FK_ZERO,W(1,23))
C     Amplitude(s) for diagram number 90
      CALL FFV1_0(W(1,6),W(1,20),W(1,23),GC_11,AMP(90))
C     Amplitude(s) for diagram number 91
      CALL FFV1_0(W(1,4),W(1,20),W(1,9),GC_11,AMP(91))
C     Amplitude(s) for diagram number 92
      CALL FFV1_0(W(1,18),W(1,5),W(1,23),GC_11,AMP(92))
      CALL FFV1P0_3(W(1,29),W(1,5),GC_11,ZERO, FK_ZERO,W(1,23))
C     Amplitude(s) for diagram number 93
      CALL FFV1_0(W(1,6),W(1,34),W(1,23),GC_11,AMP(93))
      CALL FFV1P0_3(W(1,29),W(1,3),GC_11,ZERO, FK_ZERO,W(1,9))
C     Amplitude(s) for diagram number 94
      CALL FFV1_0(W(1,6),W(1,20),W(1,9),GC_11,AMP(94))
C     Amplitude(s) for diagram number 95
      CALL FFV1_0(W(1,18),W(1,5),W(1,9),GC_11,AMP(95))
C     Amplitude(s) for diagram number 96
      CALL FFV1_0(W(1,18),W(1,3),W(1,23),GC_11,AMP(96))
      CALL FFV1P0_3(W(1,4),W(1,21),GC_11,ZERO, FK_ZERO,W(1,23))
C     Amplitude(s) for diagram number 97
      CALL FFV1_0(W(1,6),W(1,34),W(1,23),GC_11,AMP(97))
      CALL FFV1P0_3(W(1,6),W(1,21),GC_11,ZERO, FK_ZERO,W(1,9))
C     Amplitude(s) for diagram number 98
      CALL FFV1_0(W(1,4),W(1,34),W(1,9),GC_11,AMP(98))
C     Amplitude(s) for diagram number 99
      CALL FFV1_0(W(1,28),W(1,3),W(1,9),GC_11,AMP(99))
C     Amplitude(s) for diagram number 100
      CALL FFV1_0(W(1,18),W(1,3),W(1,23),GC_11,AMP(100))
      CALL FFV1P0_3(W(1,22),W(1,5),GC_11,ZERO, FK_ZERO,W(1,23))
C     Amplitude(s) for diagram number 101
      CALL FFV1_0(W(1,4),W(1,34),W(1,23),GC_11,AMP(101))
      CALL FFV1P0_3(W(1,22),W(1,3),GC_11,ZERO, FK_ZERO,W(1,34))
C     Amplitude(s) for diagram number 102
      CALL FFV1_0(W(1,28),W(1,5),W(1,34),GC_11,AMP(102))
C     Amplitude(s) for diagram number 103
      CALL FFV1_0(W(1,28),W(1,3),W(1,23),GC_11,AMP(103))
C     Amplitude(s) for diagram number 104
      CALL FFV1_0(W(1,4),W(1,20),W(1,34),GC_11,AMP(104))
      CALL FFV2_3(W(1,8),W(1,1),GC_100,MDL_MW, ZERO,W(1,34))
      CALL FFV2_3(W(1,2),W(1,7),GC_100,MDL_MW, ZERO,W(1,20))
      CALL VVV1P0_1(W(1,34),W(1,20),-GC_3,ZERO, FK_ZERO,W(1,23))
C     Amplitude(s) for diagram number 105
      CALL FFV1_0(W(1,6),W(1,12),W(1,23),GC_1,AMP(105))
      CALL VVS1_3(W(1,34),W(1,20),GC_72,MDL_MH, FK_MDL_WH,W(1,28))
C     Amplitude(s) for diagram number 106
      CALL FFS4_0(W(1,6),W(1,12),W(1,28),GC_83,AMP(106))
      CALL VVV1_3(W(1,34),W(1,20),GC_53,MDL_MZ, FK_MDL_WZ,W(1,22))
C     Amplitude(s) for diagram number 107
      CALL FFV2_3_0(W(1,6),W(1,12),W(1,22),GC_50,GC_58,AMP(107))
C     Amplitude(s) for diagram number 108
      CALL FFV1_0(W(1,11),W(1,5),W(1,23),GC_1,AMP(108))
C     Amplitude(s) for diagram number 109
      CALL FFS4_0(W(1,11),W(1,5),W(1,28),GC_83,AMP(109))
C     Amplitude(s) for diagram number 110
      CALL FFV2_3_0(W(1,11),W(1,5),W(1,22),GC_50,GC_58,AMP(110))
      CALL FFV2_2(W(1,6),W(1,34),GC_100,MDL_MT, ZERO,W(1,18))
      CALL FFV2_1(W(1,5),W(1,20),GC_100,MDL_MT, ZERO,W(1,9))
C     Amplitude(s) for diagram number 111
      CALL FFV1_0(W(1,18),W(1,9),W(1,10),GC_11,AMP(111))
C     Amplitude(s) for diagram number 112
      CALL FFV2_0(W(1,18),W(1,12),W(1,20),GC_100,AMP(112))
C     Amplitude(s) for diagram number 113
      CALL FFV2_0(W(1,11),W(1,9),W(1,34),GC_100,AMP(113))
C     Amplitude(s) for diagram number 114
      CALL FFV1_0(W(1,25),W(1,5),W(1,23),GC_1,AMP(114))
C     Amplitude(s) for diagram number 115
      CALL FFS4_0(W(1,25),W(1,5),W(1,28),GC_83,AMP(115))
C     Amplitude(s) for diagram number 116
      CALL FFV2_3_0(W(1,25),W(1,5),W(1,22),GC_50,GC_58,AMP(116))
C     Amplitude(s) for diagram number 117
      CALL FFV1_0(W(1,4),W(1,26),W(1,23),GC_1,AMP(117))
C     Amplitude(s) for diagram number 118
      CALL FFS4_0(W(1,4),W(1,26),W(1,28),GC_83,AMP(118))
C     Amplitude(s) for diagram number 119
      CALL FFV2_3_0(W(1,4),W(1,26),W(1,22),GC_50,GC_58,AMP(119))
      CALL FFV2_2(W(1,4),W(1,34),GC_100,MDL_MT, ZERO,W(1,10))
C     Amplitude(s) for diagram number 120
      CALL FFV1_0(W(1,10),W(1,9),W(1,24),GC_11,AMP(120))
C     Amplitude(s) for diagram number 121
      CALL FFV2_0(W(1,10),W(1,26),W(1,20),GC_100,AMP(121))
C     Amplitude(s) for diagram number 122
      CALL FFV2_0(W(1,25),W(1,9),W(1,34),GC_100,AMP(122))
C     Amplitude(s) for diagram number 123
      CALL FFV1_0(W(1,6),W(1,31),W(1,23),GC_1,AMP(123))
C     Amplitude(s) for diagram number 124
      CALL FFS4_0(W(1,6),W(1,31),W(1,28),GC_83,AMP(124))
C     Amplitude(s) for diagram number 125
      CALL FFV2_3_0(W(1,6),W(1,31),W(1,22),GC_50,GC_58,AMP(125))
C     Amplitude(s) for diagram number 126
      CALL FFV1_0(W(1,32),W(1,3),W(1,23),GC_1,AMP(126))
C     Amplitude(s) for diagram number 127
      CALL FFS4_0(W(1,32),W(1,3),W(1,28),GC_83,AMP(127))
C     Amplitude(s) for diagram number 128
      CALL FFV2_3_0(W(1,32),W(1,3),W(1,22),GC_50,GC_58,AMP(128))
      CALL FFV2_1(W(1,3),W(1,20),GC_100,MDL_MT, ZERO,W(1,9))
C     Amplitude(s) for diagram number 129
      CALL FFV1_0(W(1,18),W(1,9),W(1,30),GC_11,AMP(129))
C     Amplitude(s) for diagram number 130
      CALL FFV2_0(W(1,18),W(1,31),W(1,20),GC_100,AMP(130))
C     Amplitude(s) for diagram number 131
      CALL FFV2_0(W(1,32),W(1,9),W(1,34),GC_100,AMP(131))
C     Amplitude(s) for diagram number 132
      CALL FFV1_0(W(1,4),W(1,37),W(1,23),GC_1,AMP(132))
C     Amplitude(s) for diagram number 133
      CALL FFS4_0(W(1,4),W(1,37),W(1,28),GC_83,AMP(133))
C     Amplitude(s) for diagram number 134
      CALL FFV2_3_0(W(1,4),W(1,37),W(1,22),GC_50,GC_58,AMP(134))
C     Amplitude(s) for diagram number 135
      CALL FFV1_0(W(1,38),W(1,3),W(1,23),GC_1,AMP(135))
C     Amplitude(s) for diagram number 136
      CALL FFS4_0(W(1,38),W(1,3),W(1,28),GC_83,AMP(136))
C     Amplitude(s) for diagram number 137
      CALL FFV2_3_0(W(1,38),W(1,3),W(1,22),GC_50,GC_58,AMP(137))
C     Amplitude(s) for diagram number 138
      CALL FFV1_0(W(1,10),W(1,9),W(1,36),GC_11,AMP(138))
C     Amplitude(s) for diagram number 139
      CALL FFV2_0(W(1,10),W(1,37),W(1,20),GC_100,AMP(139))
C     Amplitude(s) for diagram number 140
      CALL FFV2_0(W(1,38),W(1,9),W(1,34),GC_100,AMP(140))
      CALL FFV2_2(W(1,2),W(1,34),GC_100,ZERO, FK_ZERO,W(1,9))
      CALL FFV2_3(W(1,9),W(1,7),GC_62,MDL_MZ, FK_MDL_WZ,W(1,10))
C     Amplitude(s) for diagram number 141
      CALL FFV2_3_0(W(1,6),W(1,12),W(1,10),GC_50,GC_58,AMP(141))
C     Amplitude(s) for diagram number 142
      CALL FFV2_3_0(W(1,11),W(1,5),W(1,10),GC_50,GC_58,AMP(142))
      CALL FFV2_1(W(1,7),W(1,34),GC_100,ZERO, FK_ZERO,W(1,9))
      CALL FFV1P0_3(W(1,2),W(1,9),GC_3,ZERO, FK_ZERO,W(1,34))
C     Amplitude(s) for diagram number 143
      CALL FFV1_0(W(1,6),W(1,12),W(1,34),GC_1,AMP(143))
      CALL FFV2_4_3(W(1,2),W(1,9),GC_50,GC_59,MDL_MZ, FK_MDL_WZ,W(1,7))
C     Amplitude(s) for diagram number 144
      CALL FFV2_3_0(W(1,6),W(1,12),W(1,7),GC_50,GC_58,AMP(144))
C     Amplitude(s) for diagram number 145
      CALL FFV1_0(W(1,11),W(1,5),W(1,34),GC_1,AMP(145))
C     Amplitude(s) for diagram number 146
      CALL FFV2_3_0(W(1,11),W(1,5),W(1,7),GC_50,GC_58,AMP(146))
C     Amplitude(s) for diagram number 147
      CALL FFV2_3_0(W(1,25),W(1,5),W(1,10),GC_50,GC_58,AMP(147))
C     Amplitude(s) for diagram number 148
      CALL FFV2_3_0(W(1,4),W(1,26),W(1,10),GC_50,GC_58,AMP(148))
C     Amplitude(s) for diagram number 149
      CALL FFV1_0(W(1,25),W(1,5),W(1,34),GC_1,AMP(149))
C     Amplitude(s) for diagram number 150
      CALL FFV2_3_0(W(1,25),W(1,5),W(1,7),GC_50,GC_58,AMP(150))
C     Amplitude(s) for diagram number 151
      CALL FFV1_0(W(1,4),W(1,26),W(1,34),GC_1,AMP(151))
C     Amplitude(s) for diagram number 152
      CALL FFV2_3_0(W(1,4),W(1,26),W(1,7),GC_50,GC_58,AMP(152))
C     Amplitude(s) for diagram number 153
      CALL FFV2_3_0(W(1,6),W(1,31),W(1,10),GC_50,GC_58,AMP(153))
C     Amplitude(s) for diagram number 154
      CALL FFV2_3_0(W(1,32),W(1,3),W(1,10),GC_50,GC_58,AMP(154))
C     Amplitude(s) for diagram number 155
      CALL FFV1_0(W(1,6),W(1,31),W(1,34),GC_1,AMP(155))
C     Amplitude(s) for diagram number 156
      CALL FFV2_3_0(W(1,6),W(1,31),W(1,7),GC_50,GC_58,AMP(156))
C     Amplitude(s) for diagram number 157
      CALL FFV1_0(W(1,32),W(1,3),W(1,34),GC_1,AMP(157))
C     Amplitude(s) for diagram number 158
      CALL FFV2_3_0(W(1,32),W(1,3),W(1,7),GC_50,GC_58,AMP(158))
C     Amplitude(s) for diagram number 159
      CALL FFV2_3_0(W(1,4),W(1,37),W(1,10),GC_50,GC_58,AMP(159))
C     Amplitude(s) for diagram number 160
      CALL FFV2_3_0(W(1,38),W(1,3),W(1,10),GC_50,GC_58,AMP(160))
C     Amplitude(s) for diagram number 161
      CALL FFV1_0(W(1,4),W(1,37),W(1,34),GC_1,AMP(161))
C     Amplitude(s) for diagram number 162
      CALL FFV2_3_0(W(1,4),W(1,37),W(1,7),GC_50,GC_58,AMP(162))
C     Amplitude(s) for diagram number 163
      CALL FFV1_0(W(1,38),W(1,3),W(1,34),GC_1,AMP(163))
C     Amplitude(s) for diagram number 164
      CALL FFV2_3_0(W(1,38),W(1,3),W(1,7),GC_50,GC_58,AMP(164))
      CALL FFV2_1(W(1,1),W(1,20),GC_100,ZERO, FK_ZERO,W(1,7))
      CALL FFV2_3(W(1,8),W(1,7),GC_62,MDL_MZ, FK_MDL_WZ,W(1,34))
C     Amplitude(s) for diagram number 165
      CALL FFV2_3_0(W(1,6),W(1,12),W(1,34),GC_50,GC_58,AMP(165))
C     Amplitude(s) for diagram number 166
      CALL FFV2_3_0(W(1,11),W(1,5),W(1,34),GC_50,GC_58,AMP(166))
      CALL FFV2_2(W(1,8),W(1,20),GC_100,ZERO, FK_ZERO,W(1,7))
      CALL FFV1P0_3(W(1,7),W(1,1),GC_3,ZERO, FK_ZERO,W(1,20))
C     Amplitude(s) for diagram number 167
      CALL FFV1_0(W(1,6),W(1,12),W(1,20),GC_1,AMP(167))
      CALL FFV2_4_3(W(1,7),W(1,1),GC_50,GC_59,MDL_MZ, FK_MDL_WZ,W(1,8))
C     Amplitude(s) for diagram number 168
      CALL FFV2_3_0(W(1,6),W(1,12),W(1,8),GC_50,GC_58,AMP(168))
C     Amplitude(s) for diagram number 169
      CALL FFV1_0(W(1,11),W(1,5),W(1,20),GC_1,AMP(169))
C     Amplitude(s) for diagram number 170
      CALL FFV2_3_0(W(1,11),W(1,5),W(1,8),GC_50,GC_58,AMP(170))
C     Amplitude(s) for diagram number 171
      CALL FFV2_3_0(W(1,25),W(1,5),W(1,34),GC_50,GC_58,AMP(171))
C     Amplitude(s) for diagram number 172
      CALL FFV2_3_0(W(1,4),W(1,26),W(1,34),GC_50,GC_58,AMP(172))
C     Amplitude(s) for diagram number 173
      CALL FFV1_0(W(1,25),W(1,5),W(1,20),GC_1,AMP(173))
C     Amplitude(s) for diagram number 174
      CALL FFV2_3_0(W(1,25),W(1,5),W(1,8),GC_50,GC_58,AMP(174))
C     Amplitude(s) for diagram number 175
      CALL FFV1_0(W(1,4),W(1,26),W(1,20),GC_1,AMP(175))
C     Amplitude(s) for diagram number 176
      CALL FFV2_3_0(W(1,4),W(1,26),W(1,8),GC_50,GC_58,AMP(176))
C     Amplitude(s) for diagram number 177
      CALL FFV2_3_0(W(1,6),W(1,31),W(1,34),GC_50,GC_58,AMP(177))
C     Amplitude(s) for diagram number 178
      CALL FFV2_3_0(W(1,32),W(1,3),W(1,34),GC_50,GC_58,AMP(178))
C     Amplitude(s) for diagram number 179
      CALL FFV1_0(W(1,6),W(1,31),W(1,20),GC_1,AMP(179))
C     Amplitude(s) for diagram number 180
      CALL FFV2_3_0(W(1,6),W(1,31),W(1,8),GC_50,GC_58,AMP(180))
C     Amplitude(s) for diagram number 181
      CALL FFV1_0(W(1,32),W(1,3),W(1,20),GC_1,AMP(181))
C     Amplitude(s) for diagram number 182
      CALL FFV2_3_0(W(1,32),W(1,3),W(1,8),GC_50,GC_58,AMP(182))
C     Amplitude(s) for diagram number 183
      CALL FFV2_3_0(W(1,4),W(1,37),W(1,34),GC_50,GC_58,AMP(183))
C     Amplitude(s) for diagram number 184
      CALL FFV2_3_0(W(1,38),W(1,3),W(1,34),GC_50,GC_58,AMP(184))
C     Amplitude(s) for diagram number 185
      CALL FFV1_0(W(1,4),W(1,37),W(1,20),GC_1,AMP(185))
C     Amplitude(s) for diagram number 186
      CALL FFV2_3_0(W(1,4),W(1,37),W(1,8),GC_50,GC_58,AMP(186))
C     Amplitude(s) for diagram number 187
      CALL FFV1_0(W(1,38),W(1,3),W(1,20),GC_1,AMP(187))
C     Amplitude(s) for diagram number 188
      CALL FFV2_3_0(W(1,38),W(1,3),W(1,8),GC_50,GC_58,AMP(188))
      CALL FFV2_4_1(W(1,1),W(1,16),GC_50,GC_59,ZERO, FK_ZERO,W(1,8))
      CALL FFV1P0_3(W(1,2),W(1,8),GC_3,ZERO, FK_ZERO,W(1,20))
C     Amplitude(s) for diagram number 189
      CALL FFV1_0(W(1,6),W(1,12),W(1,20),GC_1,AMP(189))
      CALL FFV2_4_3(W(1,2),W(1,8),GC_50,GC_59,MDL_MZ, FK_MDL_WZ,W(1,34)
     $ )
C     Amplitude(s) for diagram number 190
      CALL FFV2_3_0(W(1,6),W(1,12),W(1,34),GC_50,GC_58,AMP(190))
C     Amplitude(s) for diagram number 191
      CALL FFV1_0(W(1,11),W(1,5),W(1,20),GC_1,AMP(191))
C     Amplitude(s) for diagram number 192
      CALL FFV2_3_0(W(1,11),W(1,5),W(1,34),GC_50,GC_58,AMP(192))
      CALL FFV2_4_2(W(1,2),W(1,16),GC_50,GC_59,ZERO, FK_ZERO,W(1,8))
      CALL FFV1P0_3(W(1,8),W(1,1),GC_3,ZERO, FK_ZERO,W(1,16))
C     Amplitude(s) for diagram number 193
      CALL FFV1_0(W(1,6),W(1,12),W(1,16),GC_1,AMP(193))
      CALL FFV2_4_3(W(1,8),W(1,1),GC_50,GC_59,MDL_MZ, FK_MDL_WZ,W(1,2))
C     Amplitude(s) for diagram number 194
      CALL FFV2_3_0(W(1,6),W(1,12),W(1,2),GC_50,GC_58,AMP(194))
C     Amplitude(s) for diagram number 195
      CALL FFV1_0(W(1,11),W(1,5),W(1,16),GC_1,AMP(195))
C     Amplitude(s) for diagram number 196
      CALL FFV2_3_0(W(1,11),W(1,5),W(1,2),GC_50,GC_58,AMP(196))
C     Amplitude(s) for diagram number 197
      CALL FFV1_0(W(1,25),W(1,5),W(1,20),GC_1,AMP(197))
C     Amplitude(s) for diagram number 198
      CALL FFV2_3_0(W(1,25),W(1,5),W(1,34),GC_50,GC_58,AMP(198))
C     Amplitude(s) for diagram number 199
      CALL FFV1_0(W(1,4),W(1,26),W(1,20),GC_1,AMP(199))
C     Amplitude(s) for diagram number 200
      CALL FFV2_3_0(W(1,4),W(1,26),W(1,34),GC_50,GC_58,AMP(200))
C     Amplitude(s) for diagram number 201
      CALL FFV1_0(W(1,25),W(1,5),W(1,16),GC_1,AMP(201))
C     Amplitude(s) for diagram number 202
      CALL FFV2_3_0(W(1,25),W(1,5),W(1,2),GC_50,GC_58,AMP(202))
C     Amplitude(s) for diagram number 203
      CALL FFV1_0(W(1,4),W(1,26),W(1,16),GC_1,AMP(203))
C     Amplitude(s) for diagram number 204
      CALL FFV2_3_0(W(1,4),W(1,26),W(1,2),GC_50,GC_58,AMP(204))
C     Amplitude(s) for diagram number 205
      CALL FFV1_0(W(1,6),W(1,31),W(1,20),GC_1,AMP(205))
C     Amplitude(s) for diagram number 206
      CALL FFV2_3_0(W(1,6),W(1,31),W(1,34),GC_50,GC_58,AMP(206))
C     Amplitude(s) for diagram number 207
      CALL FFV1_0(W(1,32),W(1,3),W(1,20),GC_1,AMP(207))
C     Amplitude(s) for diagram number 208
      CALL FFV2_3_0(W(1,32),W(1,3),W(1,34),GC_50,GC_58,AMP(208))
C     Amplitude(s) for diagram number 209
      CALL FFV1_0(W(1,6),W(1,31),W(1,16),GC_1,AMP(209))
C     Amplitude(s) for diagram number 210
      CALL FFV2_3_0(W(1,6),W(1,31),W(1,2),GC_50,GC_58,AMP(210))
C     Amplitude(s) for diagram number 211
      CALL FFV1_0(W(1,32),W(1,3),W(1,16),GC_1,AMP(211))
C     Amplitude(s) for diagram number 212
      CALL FFV2_3_0(W(1,32),W(1,3),W(1,2),GC_50,GC_58,AMP(212))
C     Amplitude(s) for diagram number 213
      CALL FFV1_0(W(1,4),W(1,37),W(1,20),GC_1,AMP(213))
C     Amplitude(s) for diagram number 214
      CALL FFV2_3_0(W(1,4),W(1,37),W(1,34),GC_50,GC_58,AMP(214))
C     Amplitude(s) for diagram number 215
      CALL FFV1_0(W(1,38),W(1,3),W(1,20),GC_1,AMP(215))
C     Amplitude(s) for diagram number 216
      CALL FFV2_3_0(W(1,38),W(1,3),W(1,34),GC_50,GC_58,AMP(216))
C     Amplitude(s) for diagram number 217
      CALL FFV1_0(W(1,4),W(1,37),W(1,16),GC_1,AMP(217))
C     Amplitude(s) for diagram number 218
      CALL FFV2_3_0(W(1,4),W(1,37),W(1,2),GC_50,GC_58,AMP(218))
C     Amplitude(s) for diagram number 219
      CALL FFV1_0(W(1,38),W(1,3),W(1,16),GC_1,AMP(219))
C     Amplitude(s) for diagram number 220
      CALL FFV2_3_0(W(1,38),W(1,3),W(1,2),GC_50,GC_58,AMP(220))
C     JAMPs contributing to orders ALL_ORDERS=1
      TMP_JAMP(110) = AMP(219) +  AMP(220)  ! used 2 times
      TMP_JAMP(109) = AMP(217) +  AMP(218)  ! used 2 times
      TMP_JAMP(108) = AMP(215) +  AMP(216)  ! used 2 times
      TMP_JAMP(107) = AMP(213) +  AMP(214)  ! used 2 times
      TMP_JAMP(106) = AMP(211) +  AMP(212)  ! used 2 times
      TMP_JAMP(105) = AMP(209) +  AMP(210)  ! used 2 times
      TMP_JAMP(104) = AMP(207) +  AMP(208)  ! used 2 times
      TMP_JAMP(103) = AMP(205) +  AMP(206)  ! used 2 times
      TMP_JAMP(102) = AMP(203) +  AMP(204)  ! used 2 times
      TMP_JAMP(101) = AMP(201) +  AMP(202)  ! used 2 times
      TMP_JAMP(100) = AMP(199) +  AMP(200)  ! used 2 times
      TMP_JAMP(99) = AMP(197) +  AMP(198)  ! used 2 times
      TMP_JAMP(98) = AMP(195) +  AMP(196)  ! used 2 times
      TMP_JAMP(97) = AMP(193) +  AMP(194)  ! used 2 times
      TMP_JAMP(96) = AMP(191) +  AMP(192)  ! used 2 times
      TMP_JAMP(95) = AMP(189) +  AMP(190)  ! used 2 times
      TMP_JAMP(94) = AMP(187) +  AMP(188)  ! used 2 times
      TMP_JAMP(93) = AMP(185) +  AMP(186)  ! used 2 times
      TMP_JAMP(92) = AMP(183) +  AMP(184)  ! used 2 times
      TMP_JAMP(91) = AMP(181) +  AMP(182)  ! used 2 times
      TMP_JAMP(90) = AMP(179) +  AMP(180)  ! used 2 times
      TMP_JAMP(89) = AMP(177) +  AMP(178)  ! used 2 times
      TMP_JAMP(88) = AMP(175) +  AMP(176)  ! used 2 times
      TMP_JAMP(87) = AMP(173) +  AMP(174)  ! used 2 times
      TMP_JAMP(86) = AMP(171) +  AMP(172)  ! used 2 times
      TMP_JAMP(85) = AMP(169) +  AMP(170)  ! used 2 times
      TMP_JAMP(84) = AMP(167) +  AMP(168)  ! used 2 times
      TMP_JAMP(83) = AMP(165) +  AMP(166)  ! used 2 times
      TMP_JAMP(82) = AMP(163) +  AMP(164)  ! used 2 times
      TMP_JAMP(81) = AMP(161) +  AMP(162)  ! used 2 times
      TMP_JAMP(80) = AMP(159) +  AMP(160)  ! used 2 times
      TMP_JAMP(79) = AMP(157) +  AMP(158)  ! used 2 times
      TMP_JAMP(78) = AMP(155) +  AMP(156)  ! used 2 times
      TMP_JAMP(77) = AMP(153) +  AMP(154)  ! used 2 times
      TMP_JAMP(76) = AMP(151) +  AMP(152)  ! used 2 times
      TMP_JAMP(75) = AMP(149) +  AMP(150)  ! used 2 times
      TMP_JAMP(74) = AMP(147) +  AMP(148)  ! used 2 times
      TMP_JAMP(73) = AMP(145) +  AMP(146)  ! used 2 times
      TMP_JAMP(72) = AMP(143) +  AMP(144)  ! used 2 times
      TMP_JAMP(71) = AMP(141) +  AMP(142)  ! used 2 times
      TMP_JAMP(70) = AMP(139) +  AMP(140)  ! used 2 times
      TMP_JAMP(69) = AMP(137) +  AMP(138)  ! used 2 times
      TMP_JAMP(68) = AMP(135) +  AMP(136)  ! used 2 times
      TMP_JAMP(67) = AMP(133) +  AMP(134)  ! used 2 times
      TMP_JAMP(66) = AMP(130) +  AMP(131)  ! used 2 times
      TMP_JAMP(65) = AMP(128) +  AMP(129)  ! used 2 times
      TMP_JAMP(64) = AMP(126) +  AMP(127)  ! used 2 times
      TMP_JAMP(63) = AMP(124) +  AMP(125)  ! used 2 times
      TMP_JAMP(62) = AMP(122) +  AMP(123)  ! used 2 times
      TMP_JAMP(61) = AMP(120) +  AMP(121)  ! used 2 times
      TMP_JAMP(60) = AMP(118) +  AMP(119)  ! used 2 times
      TMP_JAMP(59) = AMP(116) +  AMP(117)  ! used 2 times
      TMP_JAMP(58) = AMP(114) +  AMP(115)  ! used 2 times
      TMP_JAMP(57) = AMP(113) +  AMP(132)  ! used 2 times
      TMP_JAMP(56) = AMP(111) +  AMP(112)  ! used 2 times
      TMP_JAMP(55) = AMP(109) +  AMP(110)  ! used 2 times
      TMP_JAMP(54) = AMP(107) +  AMP(108)  ! used 2 times
      TMP_JAMP(53) = AMP(105) +  AMP(106)  ! used 2 times
      TMP_JAMP(52) = AMP(102) +  AMP(104)  ! used 2 times
      TMP_JAMP(51) = AMP(101) +  AMP(103)  ! used 2 times
      TMP_JAMP(50) = AMP(98) +  AMP(99)  ! used 2 times
      TMP_JAMP(49) = AMP(97) +  AMP(100)  ! used 2 times
      TMP_JAMP(48) = AMP(94) +  AMP(95)  ! used 2 times
      TMP_JAMP(47) = AMP(93) +  AMP(96)  ! used 2 times
      TMP_JAMP(46) = AMP(90) +  AMP(92)  ! used 2 times
      TMP_JAMP(45) = AMP(89) +  AMP(91)  ! used 2 times
      TMP_JAMP(44) = AMP(86) +  AMP(88)  ! used 2 times
      TMP_JAMP(43) = AMP(85) +  AMP(87)  ! used 2 times
      TMP_JAMP(42) = AMP(82) +  AMP(83)  ! used 2 times
      TMP_JAMP(41) = AMP(81) +  AMP(84)  ! used 2 times
      TMP_JAMP(40) = AMP(78) +  AMP(79)  ! used 2 times
      TMP_JAMP(39) = AMP(77) +  AMP(80)  ! used 2 times
      TMP_JAMP(38) = AMP(74) +  AMP(76)  ! used 2 times
      TMP_JAMP(37) = AMP(73) +  AMP(75)  ! used 2 times
      TMP_JAMP(36) = AMP(71) +  AMP(72)  ! used 2 times
      TMP_JAMP(35) = AMP(69) +  AMP(70)  ! used 2 times
      TMP_JAMP(34) = AMP(67) +  AMP(68)  ! used 2 times
      TMP_JAMP(33) = AMP(65) +  AMP(66)  ! used 2 times
      TMP_JAMP(32) = AMP(63) +  AMP(64)  ! used 2 times
      TMP_JAMP(31) = AMP(61) +  AMP(62)  ! used 2 times
      TMP_JAMP(30) = AMP(59) +  AMP(60)  ! used 2 times
      TMP_JAMP(29) = AMP(57) +  AMP(58)  ! used 2 times
      TMP_JAMP(28) = AMP(55) +  AMP(56)  ! used 2 times
      TMP_JAMP(27) = AMP(53) +  AMP(54)  ! used 2 times
      TMP_JAMP(26) = AMP(51) +  AMP(52)  ! used 2 times
      TMP_JAMP(25) = AMP(49) +  AMP(50)  ! used 2 times
      TMP_JAMP(24) = AMP(47) +  AMP(48)  ! used 2 times
      TMP_JAMP(23) = AMP(45) +  AMP(46)  ! used 2 times
      TMP_JAMP(22) = AMP(43) +  AMP(44)  ! used 2 times
      TMP_JAMP(21) = AMP(41) +  AMP(42)  ! used 2 times
      TMP_JAMP(20) = AMP(39) +  AMP(40)  ! used 2 times
      TMP_JAMP(19) = AMP(37) +  AMP(38)  ! used 2 times
      TMP_JAMP(18) = AMP(35) +  AMP(36)  ! used 2 times
      TMP_JAMP(17) = AMP(33) +  AMP(34)  ! used 2 times
      TMP_JAMP(16) = AMP(31) +  AMP(32)  ! used 2 times
      TMP_JAMP(15) = AMP(29) +  AMP(30)  ! used 2 times
      TMP_JAMP(14) = AMP(27) +  AMP(28)  ! used 2 times
      TMP_JAMP(13) = AMP(25) +  AMP(26)  ! used 2 times
      TMP_JAMP(12) = AMP(23) +  AMP(24)  ! used 2 times
      TMP_JAMP(11) = AMP(21) +  AMP(22)  ! used 2 times
      TMP_JAMP(10) = AMP(19) +  AMP(20)  ! used 2 times
      TMP_JAMP(9) = AMP(17) +  AMP(18)  ! used 2 times
      TMP_JAMP(8) = AMP(15) +  AMP(16)  ! used 2 times
      TMP_JAMP(7) = AMP(13) +  AMP(14)  ! used 2 times
      TMP_JAMP(6) = AMP(11) +  AMP(12)  ! used 2 times
      TMP_JAMP(5) = AMP(9) +  AMP(10)  ! used 2 times
      TMP_JAMP(4) = AMP(7) +  AMP(8)  ! used 2 times
      TMP_JAMP(3) = AMP(5) +  AMP(6)  ! used 2 times
      TMP_JAMP(2) = AMP(3) +  AMP(4)  ! used 2 times
      TMP_JAMP(1) = AMP(1) +  AMP(2)  ! used 2 times
      TMP_JAMP(164) = TMP_JAMP(3) +  TMP_JAMP(2)  ! used 2 times
      TMP_JAMP(163) = TMP_JAMP(5) +  TMP_JAMP(4)  ! used 2 times
      TMP_JAMP(162) = TMP_JAMP(7) +  TMP_JAMP(6)  ! used 2 times
      TMP_JAMP(161) = TMP_JAMP(9) +  TMP_JAMP(8)  ! used 2 times
      TMP_JAMP(160) = TMP_JAMP(12) +  TMP_JAMP(11)  ! used 2 times
      TMP_JAMP(159) = TMP_JAMP(14) +  TMP_JAMP(13)  ! used 2 times
      TMP_JAMP(158) = TMP_JAMP(16) +  TMP_JAMP(15)  ! used 2 times
      TMP_JAMP(157) = TMP_JAMP(18) +  TMP_JAMP(17)  ! used 2 times
      TMP_JAMP(156) = TMP_JAMP(20) +  TMP_JAMP(19)  ! used 2 times
      TMP_JAMP(155) = TMP_JAMP(22) +  TMP_JAMP(21)  ! used 2 times
      TMP_JAMP(154) = TMP_JAMP(24) +  TMP_JAMP(23)  ! used 2 times
      TMP_JAMP(153) = TMP_JAMP(26) +  TMP_JAMP(25)  ! used 2 times
      TMP_JAMP(152) = TMP_JAMP(29) +  TMP_JAMP(28)  ! used 2 times
      TMP_JAMP(151) = TMP_JAMP(31) +  TMP_JAMP(30)  ! used 2 times
      TMP_JAMP(150) = TMP_JAMP(33) +  TMP_JAMP(32)  ! used 2 times
      TMP_JAMP(149) = TMP_JAMP(35) +  TMP_JAMP(34)  ! used 2 times
      TMP_JAMP(148) = TMP_JAMP(37) +  TMP_JAMP(27)  ! used 2 times
      TMP_JAMP(147) = TMP_JAMP(38) +  TMP_JAMP(36)  ! used 2 times
      TMP_JAMP(146) = TMP_JAMP(41) +  TMP_JAMP(39)  ! used 2 times
      TMP_JAMP(145) = TMP_JAMP(42) +  TMP_JAMP(40)  ! used 2 times
      TMP_JAMP(144) = TMP_JAMP(45) +  TMP_JAMP(44)  ! used 2 times
      TMP_JAMP(143) = TMP_JAMP(46) +  TMP_JAMP(43)  ! used 2 times
      TMP_JAMP(142) = TMP_JAMP(49) +  TMP_JAMP(47)  ! used 2 times
      TMP_JAMP(141) = TMP_JAMP(50) +  TMP_JAMP(48)  ! used 2 times
      TMP_JAMP(140) = TMP_JAMP(53) - TMP_JAMP(51)  ! used 2 times
      TMP_JAMP(139) = TMP_JAMP(55) +  TMP_JAMP(54)  ! used 2 times
      TMP_JAMP(138) = TMP_JAMP(57) +  TMP_JAMP(56)  ! used 2 times
      TMP_JAMP(137) = TMP_JAMP(58) - TMP_JAMP(52)  ! used 2 times
      TMP_JAMP(136) = TMP_JAMP(60) +  TMP_JAMP(59)  ! used 2 times
      TMP_JAMP(135) = TMP_JAMP(62) +  TMP_JAMP(61)  ! used 2 times
      TMP_JAMP(134) = TMP_JAMP(64) +  TMP_JAMP(63)  ! used 2 times
      TMP_JAMP(133) = TMP_JAMP(66) +  TMP_JAMP(65)  ! used 2 times
      TMP_JAMP(132) = TMP_JAMP(68) +  TMP_JAMP(67)  ! used 2 times
      TMP_JAMP(131) = TMP_JAMP(70) +  TMP_JAMP(69)  ! used 2 times
      TMP_JAMP(130) = TMP_JAMP(72) +  TMP_JAMP(71)  ! used 2 times
      TMP_JAMP(129) = TMP_JAMP(75) +  TMP_JAMP(74)  ! used 2 times
      TMP_JAMP(128) = TMP_JAMP(77) +  TMP_JAMP(76)  ! used 2 times
      TMP_JAMP(127) = TMP_JAMP(79) +  TMP_JAMP(78)  ! used 2 times
      TMP_JAMP(126) = TMP_JAMP(80) +  TMP_JAMP(73)  ! used 2 times
      TMP_JAMP(125) = TMP_JAMP(82) +  TMP_JAMP(81)  ! used 2 times
      TMP_JAMP(124) = TMP_JAMP(84) +  TMP_JAMP(83)  ! used 2 times
      TMP_JAMP(123) = TMP_JAMP(87) +  TMP_JAMP(86)  ! used 2 times
      TMP_JAMP(122) = TMP_JAMP(89) +  TMP_JAMP(88)  ! used 2 times
      TMP_JAMP(121) = TMP_JAMP(91) +  TMP_JAMP(90)  ! used 2 times
      TMP_JAMP(120) = TMP_JAMP(92) +  TMP_JAMP(85)  ! used 2 times
      TMP_JAMP(119) = TMP_JAMP(94) +  TMP_JAMP(93)  ! used 2 times
      TMP_JAMP(118) = TMP_JAMP(96) +  TMP_JAMP(95)  ! used 2 times
      TMP_JAMP(117) = TMP_JAMP(98) +  TMP_JAMP(97)  ! used 2 times
      TMP_JAMP(116) = TMP_JAMP(100) +  TMP_JAMP(99)  ! used 2 times
      TMP_JAMP(115) = TMP_JAMP(102) +  TMP_JAMP(101)  ! used 2 times
      TMP_JAMP(114) = TMP_JAMP(104) +  TMP_JAMP(103)  ! used 2 times
      TMP_JAMP(113) = TMP_JAMP(106) +  TMP_JAMP(105)  ! used 2 times
      TMP_JAMP(112) = TMP_JAMP(108) +  TMP_JAMP(107)  ! used 2 times
      TMP_JAMP(111) = TMP_JAMP(110) +  TMP_JAMP(109)  ! used 2 times
      TMP_JAMP(192) = TMP_JAMP(111) +  TMP_JAMP(1)  ! used 2 times
      TMP_JAMP(191) = TMP_JAMP(113) +  TMP_JAMP(10)  ! used 2 times
      TMP_JAMP(190) = TMP_JAMP(115) +  TMP_JAMP(114)  ! used 2 times
      TMP_JAMP(189) = TMP_JAMP(117) +  TMP_JAMP(112)  ! used 2 times
      TMP_JAMP(188) = TMP_JAMP(119) - TMP_JAMP(118)  ! used 2 times
      TMP_JAMP(187) = TMP_JAMP(121) - TMP_JAMP(116)  ! used 2 times
      TMP_JAMP(186) = TMP_JAMP(123) +  TMP_JAMP(122)  ! used 2 times
      TMP_JAMP(185) = TMP_JAMP(124) +  TMP_JAMP(120)  ! used 2 times
      TMP_JAMP(184) = TMP_JAMP(126) +  TMP_JAMP(125)  ! used 2 times
      TMP_JAMP(183) = TMP_JAMP(128) +  TMP_JAMP(127)  ! used 2 times
      TMP_JAMP(182) = TMP_JAMP(131) +  TMP_JAMP(130)  ! used 2 times
      TMP_JAMP(181) = TMP_JAMP(133) +  TMP_JAMP(129)  ! used 2 times
      TMP_JAMP(180) = TMP_JAMP(135) +  TMP_JAMP(134)  ! used 2 times
      TMP_JAMP(179) = TMP_JAMP(137) +  TMP_JAMP(136)  ! used 2 times
      TMP_JAMP(178) = TMP_JAMP(138) +  TMP_JAMP(132)  ! used 2 times
      TMP_JAMP(177) = TMP_JAMP(140) +  TMP_JAMP(139)  ! used 2 times
      TMP_JAMP(176) = TMP_JAMP(143) +  TMP_JAMP(141)  ! used 2 times
      TMP_JAMP(175) = TMP_JAMP(144) +  TMP_JAMP(142)  ! used 2 times
      TMP_JAMP(174) = TMP_JAMP(147) +  TMP_JAMP(145)  ! used 2 times
      TMP_JAMP(173) = TMP_JAMP(148) +  TMP_JAMP(146)  ! used 2 times
      TMP_JAMP(172) = TMP_JAMP(150) +  TMP_JAMP(149)  ! used 2 times
      TMP_JAMP(171) = TMP_JAMP(152) +  TMP_JAMP(151)  ! used 2 times
      TMP_JAMP(170) = TMP_JAMP(154) +  TMP_JAMP(153)  ! used 2 times
      TMP_JAMP(169) = TMP_JAMP(156) +  TMP_JAMP(155)  ! used 2 times
      TMP_JAMP(168) = TMP_JAMP(158) +  TMP_JAMP(157)  ! used 2 times
      TMP_JAMP(167) = TMP_JAMP(160) +  TMP_JAMP(159)  ! used 2 times
      TMP_JAMP(166) = TMP_JAMP(162) +  TMP_JAMP(161)  ! used 2 times
      TMP_JAMP(165) = TMP_JAMP(164) +  TMP_JAMP(163)  ! used 2 times
      TMP_JAMP(206) = TMP_JAMP(166) +  TMP_JAMP(165)  ! used 2 times
      TMP_JAMP(205) = TMP_JAMP(168) +  TMP_JAMP(167)  ! used 2 times
      TMP_JAMP(204) = TMP_JAMP(170) +  TMP_JAMP(169)  ! used 2 times
      TMP_JAMP(203) = TMP_JAMP(172) +  TMP_JAMP(171)  ! used 2 times
      TMP_JAMP(202) = TMP_JAMP(175) +  TMP_JAMP(173)  ! used 2 times
      TMP_JAMP(201) = TMP_JAMP(176) +  TMP_JAMP(174)  ! used 2 times
      TMP_JAMP(200) = TMP_JAMP(178) +  TMP_JAMP(177)  ! used 2 times
      TMP_JAMP(199) = TMP_JAMP(180) +  TMP_JAMP(179)  ! used 2 times
      TMP_JAMP(198) = TMP_JAMP(183) +  TMP_JAMP(181)  ! used 2 times
      TMP_JAMP(197) = TMP_JAMP(184) +  TMP_JAMP(182)  ! used 2 times
      TMP_JAMP(196) = TMP_JAMP(187) +  TMP_JAMP(186)  ! used 2 times
      TMP_JAMP(195) = TMP_JAMP(188) +  TMP_JAMP(185)  ! used 2 times
      TMP_JAMP(194) = TMP_JAMP(191) +  TMP_JAMP(190)  ! used 2 times
      TMP_JAMP(193) = TMP_JAMP(192) +  TMP_JAMP(189)  ! used 2 times
      TMP_JAMP(212) = TMP_JAMP(197) +  TMP_JAMP(195)  ! used 2 times
      TMP_JAMP(211) = TMP_JAMP(198) +  TMP_JAMP(196)  ! used 2 times
      TMP_JAMP(210) = TMP_JAMP(201) - TMP_JAMP(200)  ! used 2 times
      TMP_JAMP(209) = TMP_JAMP(202) - TMP_JAMP(199)  ! used 2 times
      TMP_JAMP(208) = TMP_JAMP(205) +  TMP_JAMP(204)  ! used 2 times
      TMP_JAMP(207) = TMP_JAMP(206) +  TMP_JAMP(203)  ! used 2 times
      TMP_JAMP(216) = TMP_JAMP(207) +  TMP_JAMP(193)  ! used 2 times
      TMP_JAMP(215) = TMP_JAMP(208) +  TMP_JAMP(194)  ! used 2 times
      TMP_JAMP(214) = TMP_JAMP(211) - TMP_JAMP(209)  ! used 2 times
      TMP_JAMP(213) = TMP_JAMP(212) - TMP_JAMP(210)  ! used 2 times
      TMP_JAMP(218) = TMP_JAMP(215) - TMP_JAMP(214)  ! used 2 times
      TMP_JAMP(217) = TMP_JAMP(216) - TMP_JAMP(213)  ! used 2 times
      JAMP(1,1) = (-1.666666666666667D-01)*TMP_JAMP(217)+(
     $ -5.000000000000000D-01)*TMP_JAMP(218)
      JAMP(2,1) = (5.000000000000000D-01)*TMP_JAMP(217)
     $ +(1.666666666666667D-01)*TMP_JAMP(218)

      IF(INIT_MODE)THEN
        DO I=1, NGRAPHS
          IF (AMP(I).NE.0) THEN
            ZEROAMP_1(IHEL,I) = .FALSE.
          ENDIF
        ENDDO
      ENDIF

      MATRIX1 = 0.D0
      DO M = 1, NAMPSO
        DO I = 1, NCOLOR
          ZTEMP = (0.D0,0.D0)
          DO J = 1, NCOLOR
            ZTEMP = ZTEMP + CF(J,I)*JAMP(J,M)
          ENDDO
          DO N = 1, NAMPSO

            MATRIX1 = MATRIX1 + ZTEMP*DCONJG(JAMP(I,N))

          ENDDO
        ENDDO
      ENDDO

      IF(SDE_STRAT.EQ.1)THEN
        AMP2(1)=AMP2(1)+AMP(1)*DCONJG(AMP(1))
        AMP2(2)=AMP2(2)+AMP(2)*DCONJG(AMP(2))
        AMP2(3)=AMP2(3)+AMP(3)*DCONJG(AMP(3))
        AMP2(4)=AMP2(4)+AMP(4)*DCONJG(AMP(4))
        AMP2(5)=AMP2(5)+AMP(5)*DCONJG(AMP(5))
        AMP2(6)=AMP2(6)+AMP(6)*DCONJG(AMP(6))
        AMP2(7)=AMP2(7)+AMP(7)*DCONJG(AMP(7))
        AMP2(8)=AMP2(8)+AMP(8)*DCONJG(AMP(8))
        AMP2(9)=AMP2(9)+AMP(9)*DCONJG(AMP(9))
        AMP2(10)=AMP2(10)+AMP(10)*DCONJG(AMP(10))
        AMP2(11)=AMP2(11)+AMP(11)*DCONJG(AMP(11))
        AMP2(12)=AMP2(12)+AMP(12)*DCONJG(AMP(12))
        AMP2(13)=AMP2(13)+AMP(13)*DCONJG(AMP(13))
        AMP2(14)=AMP2(14)+AMP(14)*DCONJG(AMP(14))
        AMP2(15)=AMP2(15)+AMP(15)*DCONJG(AMP(15))
        AMP2(16)=AMP2(16)+AMP(16)*DCONJG(AMP(16))
        AMP2(17)=AMP2(17)+AMP(17)*DCONJG(AMP(17))
        AMP2(18)=AMP2(18)+AMP(18)*DCONJG(AMP(18))
        AMP2(19)=AMP2(19)+AMP(19)*DCONJG(AMP(19))
        AMP2(20)=AMP2(20)+AMP(20)*DCONJG(AMP(20))
        AMP2(21)=AMP2(21)+AMP(21)*DCONJG(AMP(21))
        AMP2(22)=AMP2(22)+AMP(22)*DCONJG(AMP(22))
        AMP2(23)=AMP2(23)+AMP(23)*DCONJG(AMP(23))
        AMP2(24)=AMP2(24)+AMP(24)*DCONJG(AMP(24))
        AMP2(25)=AMP2(25)+AMP(25)*DCONJG(AMP(25))
        AMP2(26)=AMP2(26)+AMP(26)*DCONJG(AMP(26))
        AMP2(27)=AMP2(27)+AMP(27)*DCONJG(AMP(27))
        AMP2(28)=AMP2(28)+AMP(28)*DCONJG(AMP(28))
        AMP2(29)=AMP2(29)+AMP(29)*DCONJG(AMP(29))
        AMP2(30)=AMP2(30)+AMP(30)*DCONJG(AMP(30))
        AMP2(31)=AMP2(31)+AMP(31)*DCONJG(AMP(31))
        AMP2(32)=AMP2(32)+AMP(32)*DCONJG(AMP(32))
        AMP2(33)=AMP2(33)+AMP(33)*DCONJG(AMP(33))
        AMP2(34)=AMP2(34)+AMP(34)*DCONJG(AMP(34))
        AMP2(35)=AMP2(35)+AMP(35)*DCONJG(AMP(35))
        AMP2(36)=AMP2(36)+AMP(36)*DCONJG(AMP(36))
        AMP2(37)=AMP2(37)+AMP(37)*DCONJG(AMP(37))
        AMP2(38)=AMP2(38)+AMP(38)*DCONJG(AMP(38))
        AMP2(39)=AMP2(39)+AMP(39)*DCONJG(AMP(39))
        AMP2(40)=AMP2(40)+AMP(40)*DCONJG(AMP(40))
        AMP2(41)=AMP2(41)+AMP(41)*DCONJG(AMP(41))
        AMP2(42)=AMP2(42)+AMP(42)*DCONJG(AMP(42))
        AMP2(43)=AMP2(43)+AMP(43)*DCONJG(AMP(43))
        AMP2(44)=AMP2(44)+AMP(44)*DCONJG(AMP(44))
        AMP2(45)=AMP2(45)+AMP(45)*DCONJG(AMP(45))
        AMP2(46)=AMP2(46)+AMP(46)*DCONJG(AMP(46))
        AMP2(47)=AMP2(47)+AMP(47)*DCONJG(AMP(47))
        AMP2(48)=AMP2(48)+AMP(48)*DCONJG(AMP(48))
        AMP2(49)=AMP2(49)+AMP(49)*DCONJG(AMP(49))
        AMP2(50)=AMP2(50)+AMP(50)*DCONJG(AMP(50))
        AMP2(51)=AMP2(51)+AMP(51)*DCONJG(AMP(51))
        AMP2(52)=AMP2(52)+AMP(52)*DCONJG(AMP(52))
        AMP2(53)=AMP2(53)+AMP(53)*DCONJG(AMP(53))
        AMP2(54)=AMP2(54)+AMP(54)*DCONJG(AMP(54))
        AMP2(55)=AMP2(55)+AMP(55)*DCONJG(AMP(55))
        AMP2(56)=AMP2(56)+AMP(56)*DCONJG(AMP(56))
        AMP2(57)=AMP2(57)+AMP(57)*DCONJG(AMP(57))
        AMP2(58)=AMP2(58)+AMP(58)*DCONJG(AMP(58))
        AMP2(59)=AMP2(59)+AMP(59)*DCONJG(AMP(59))
        AMP2(60)=AMP2(60)+AMP(60)*DCONJG(AMP(60))
        AMP2(61)=AMP2(61)+AMP(61)*DCONJG(AMP(61))
        AMP2(62)=AMP2(62)+AMP(62)*DCONJG(AMP(62))
        AMP2(63)=AMP2(63)+AMP(63)*DCONJG(AMP(63))
        AMP2(64)=AMP2(64)+AMP(64)*DCONJG(AMP(64))
        AMP2(65)=AMP2(65)+AMP(65)*DCONJG(AMP(65))
        AMP2(66)=AMP2(66)+AMP(66)*DCONJG(AMP(66))
        AMP2(67)=AMP2(67)+AMP(67)*DCONJG(AMP(67))
        AMP2(68)=AMP2(68)+AMP(68)*DCONJG(AMP(68))
        AMP2(69)=AMP2(69)+AMP(69)*DCONJG(AMP(69))
        AMP2(70)=AMP2(70)+AMP(70)*DCONJG(AMP(70))
        AMP2(71)=AMP2(71)+AMP(71)*DCONJG(AMP(71))
        AMP2(72)=AMP2(72)+AMP(72)*DCONJG(AMP(72))
        AMP2(73)=AMP2(73)+AMP(73)*DCONJG(AMP(73))
        AMP2(74)=AMP2(74)+AMP(74)*DCONJG(AMP(74))
        AMP2(75)=AMP2(75)+AMP(75)*DCONJG(AMP(75))
        AMP2(76)=AMP2(76)+AMP(76)*DCONJG(AMP(76))
        AMP2(77)=AMP2(77)+AMP(77)*DCONJG(AMP(77))
        AMP2(78)=AMP2(78)+AMP(78)*DCONJG(AMP(78))
        AMP2(79)=AMP2(79)+AMP(79)*DCONJG(AMP(79))
        AMP2(80)=AMP2(80)+AMP(80)*DCONJG(AMP(80))
        AMP2(81)=AMP2(81)+AMP(81)*DCONJG(AMP(81))
        AMP2(82)=AMP2(82)+AMP(82)*DCONJG(AMP(82))
        AMP2(83)=AMP2(83)+AMP(83)*DCONJG(AMP(83))
        AMP2(84)=AMP2(84)+AMP(84)*DCONJG(AMP(84))
        AMP2(85)=AMP2(85)+AMP(85)*DCONJG(AMP(85))
        AMP2(86)=AMP2(86)+AMP(86)*DCONJG(AMP(86))
        AMP2(87)=AMP2(87)+AMP(87)*DCONJG(AMP(87))
        AMP2(88)=AMP2(88)+AMP(88)*DCONJG(AMP(88))
        AMP2(89)=AMP2(89)+AMP(89)*DCONJG(AMP(89))
        AMP2(90)=AMP2(90)+AMP(90)*DCONJG(AMP(90))
        AMP2(91)=AMP2(91)+AMP(91)*DCONJG(AMP(91))
        AMP2(92)=AMP2(92)+AMP(92)*DCONJG(AMP(92))
        AMP2(93)=AMP2(93)+AMP(93)*DCONJG(AMP(93))
        AMP2(94)=AMP2(94)+AMP(94)*DCONJG(AMP(94))
        AMP2(95)=AMP2(95)+AMP(95)*DCONJG(AMP(95))
        AMP2(96)=AMP2(96)+AMP(96)*DCONJG(AMP(96))
        AMP2(97)=AMP2(97)+AMP(97)*DCONJG(AMP(97))
        AMP2(98)=AMP2(98)+AMP(98)*DCONJG(AMP(98))
        AMP2(99)=AMP2(99)+AMP(99)*DCONJG(AMP(99))
        AMP2(100)=AMP2(100)+AMP(100)*DCONJG(AMP(100))
        AMP2(101)=AMP2(101)+AMP(101)*DCONJG(AMP(101))
        AMP2(102)=AMP2(102)+AMP(102)*DCONJG(AMP(102))
        AMP2(103)=AMP2(103)+AMP(103)*DCONJG(AMP(103))
        AMP2(104)=AMP2(104)+AMP(104)*DCONJG(AMP(104))
        AMP2(105)=AMP2(105)+AMP(105)*DCONJG(AMP(105))
        AMP2(106)=AMP2(106)+AMP(106)*DCONJG(AMP(106))
        AMP2(107)=AMP2(107)+AMP(107)*DCONJG(AMP(107))
        AMP2(108)=AMP2(108)+AMP(108)*DCONJG(AMP(108))
        AMP2(109)=AMP2(109)+AMP(109)*DCONJG(AMP(109))
        AMP2(110)=AMP2(110)+AMP(110)*DCONJG(AMP(110))
        AMP2(111)=AMP2(111)+AMP(111)*DCONJG(AMP(111))
        AMP2(112)=AMP2(112)+AMP(112)*DCONJG(AMP(112))
        AMP2(113)=AMP2(113)+AMP(113)*DCONJG(AMP(113))
        AMP2(114)=AMP2(114)+AMP(114)*DCONJG(AMP(114))
        AMP2(115)=AMP2(115)+AMP(115)*DCONJG(AMP(115))
        AMP2(116)=AMP2(116)+AMP(116)*DCONJG(AMP(116))
        AMP2(117)=AMP2(117)+AMP(117)*DCONJG(AMP(117))
        AMP2(118)=AMP2(118)+AMP(118)*DCONJG(AMP(118))
        AMP2(119)=AMP2(119)+AMP(119)*DCONJG(AMP(119))
        AMP2(120)=AMP2(120)+AMP(120)*DCONJG(AMP(120))
        AMP2(121)=AMP2(121)+AMP(121)*DCONJG(AMP(121))
        AMP2(122)=AMP2(122)+AMP(122)*DCONJG(AMP(122))
        AMP2(123)=AMP2(123)+AMP(123)*DCONJG(AMP(123))
        AMP2(124)=AMP2(124)+AMP(124)*DCONJG(AMP(124))
        AMP2(125)=AMP2(125)+AMP(125)*DCONJG(AMP(125))
        AMP2(126)=AMP2(126)+AMP(126)*DCONJG(AMP(126))
        AMP2(127)=AMP2(127)+AMP(127)*DCONJG(AMP(127))
        AMP2(128)=AMP2(128)+AMP(128)*DCONJG(AMP(128))
        AMP2(129)=AMP2(129)+AMP(129)*DCONJG(AMP(129))
        AMP2(130)=AMP2(130)+AMP(130)*DCONJG(AMP(130))
        AMP2(131)=AMP2(131)+AMP(131)*DCONJG(AMP(131))
        AMP2(132)=AMP2(132)+AMP(132)*DCONJG(AMP(132))
        AMP2(133)=AMP2(133)+AMP(133)*DCONJG(AMP(133))
        AMP2(134)=AMP2(134)+AMP(134)*DCONJG(AMP(134))
        AMP2(135)=AMP2(135)+AMP(135)*DCONJG(AMP(135))
        AMP2(136)=AMP2(136)+AMP(136)*DCONJG(AMP(136))
        AMP2(137)=AMP2(137)+AMP(137)*DCONJG(AMP(137))
        AMP2(138)=AMP2(138)+AMP(138)*DCONJG(AMP(138))
        AMP2(139)=AMP2(139)+AMP(139)*DCONJG(AMP(139))
        AMP2(140)=AMP2(140)+AMP(140)*DCONJG(AMP(140))
        AMP2(141)=AMP2(141)+AMP(141)*DCONJG(AMP(141))
        AMP2(142)=AMP2(142)+AMP(142)*DCONJG(AMP(142))
        AMP2(143)=AMP2(143)+AMP(143)*DCONJG(AMP(143))
        AMP2(144)=AMP2(144)+AMP(144)*DCONJG(AMP(144))
        AMP2(145)=AMP2(145)+AMP(145)*DCONJG(AMP(145))
        AMP2(146)=AMP2(146)+AMP(146)*DCONJG(AMP(146))
        AMP2(147)=AMP2(147)+AMP(147)*DCONJG(AMP(147))
        AMP2(148)=AMP2(148)+AMP(148)*DCONJG(AMP(148))
        AMP2(149)=AMP2(149)+AMP(149)*DCONJG(AMP(149))
        AMP2(150)=AMP2(150)+AMP(150)*DCONJG(AMP(150))
        AMP2(151)=AMP2(151)+AMP(151)*DCONJG(AMP(151))
        AMP2(152)=AMP2(152)+AMP(152)*DCONJG(AMP(152))
        AMP2(153)=AMP2(153)+AMP(153)*DCONJG(AMP(153))
        AMP2(154)=AMP2(154)+AMP(154)*DCONJG(AMP(154))
        AMP2(155)=AMP2(155)+AMP(155)*DCONJG(AMP(155))
        AMP2(156)=AMP2(156)+AMP(156)*DCONJG(AMP(156))
        AMP2(157)=AMP2(157)+AMP(157)*DCONJG(AMP(157))
        AMP2(158)=AMP2(158)+AMP(158)*DCONJG(AMP(158))
        AMP2(159)=AMP2(159)+AMP(159)*DCONJG(AMP(159))
        AMP2(160)=AMP2(160)+AMP(160)*DCONJG(AMP(160))
        AMP2(161)=AMP2(161)+AMP(161)*DCONJG(AMP(161))
        AMP2(162)=AMP2(162)+AMP(162)*DCONJG(AMP(162))
        AMP2(163)=AMP2(163)+AMP(163)*DCONJG(AMP(163))
        AMP2(164)=AMP2(164)+AMP(164)*DCONJG(AMP(164))
        AMP2(165)=AMP2(165)+AMP(165)*DCONJG(AMP(165))
        AMP2(166)=AMP2(166)+AMP(166)*DCONJG(AMP(166))
        AMP2(167)=AMP2(167)+AMP(167)*DCONJG(AMP(167))
        AMP2(168)=AMP2(168)+AMP(168)*DCONJG(AMP(168))
        AMP2(169)=AMP2(169)+AMP(169)*DCONJG(AMP(169))
        AMP2(170)=AMP2(170)+AMP(170)*DCONJG(AMP(170))
        AMP2(171)=AMP2(171)+AMP(171)*DCONJG(AMP(171))
        AMP2(172)=AMP2(172)+AMP(172)*DCONJG(AMP(172))
        AMP2(173)=AMP2(173)+AMP(173)*DCONJG(AMP(173))
        AMP2(174)=AMP2(174)+AMP(174)*DCONJG(AMP(174))
        AMP2(175)=AMP2(175)+AMP(175)*DCONJG(AMP(175))
        AMP2(176)=AMP2(176)+AMP(176)*DCONJG(AMP(176))
        AMP2(177)=AMP2(177)+AMP(177)*DCONJG(AMP(177))
        AMP2(178)=AMP2(178)+AMP(178)*DCONJG(AMP(178))
        AMP2(179)=AMP2(179)+AMP(179)*DCONJG(AMP(179))
        AMP2(180)=AMP2(180)+AMP(180)*DCONJG(AMP(180))
        AMP2(181)=AMP2(181)+AMP(181)*DCONJG(AMP(181))
        AMP2(182)=AMP2(182)+AMP(182)*DCONJG(AMP(182))
        AMP2(183)=AMP2(183)+AMP(183)*DCONJG(AMP(183))
        AMP2(184)=AMP2(184)+AMP(184)*DCONJG(AMP(184))
        AMP2(185)=AMP2(185)+AMP(185)*DCONJG(AMP(185))
        AMP2(186)=AMP2(186)+AMP(186)*DCONJG(AMP(186))
        AMP2(187)=AMP2(187)+AMP(187)*DCONJG(AMP(187))
        AMP2(188)=AMP2(188)+AMP(188)*DCONJG(AMP(188))
        AMP2(189)=AMP2(189)+AMP(189)*DCONJG(AMP(189))
        AMP2(190)=AMP2(190)+AMP(190)*DCONJG(AMP(190))
        AMP2(191)=AMP2(191)+AMP(191)*DCONJG(AMP(191))
        AMP2(192)=AMP2(192)+AMP(192)*DCONJG(AMP(192))
        AMP2(193)=AMP2(193)+AMP(193)*DCONJG(AMP(193))
        AMP2(194)=AMP2(194)+AMP(194)*DCONJG(AMP(194))
        AMP2(195)=AMP2(195)+AMP(195)*DCONJG(AMP(195))
        AMP2(196)=AMP2(196)+AMP(196)*DCONJG(AMP(196))
        AMP2(197)=AMP2(197)+AMP(197)*DCONJG(AMP(197))
        AMP2(198)=AMP2(198)+AMP(198)*DCONJG(AMP(198))
        AMP2(199)=AMP2(199)+AMP(199)*DCONJG(AMP(199))
        AMP2(200)=AMP2(200)+AMP(200)*DCONJG(AMP(200))
        AMP2(201)=AMP2(201)+AMP(201)*DCONJG(AMP(201))
        AMP2(202)=AMP2(202)+AMP(202)*DCONJG(AMP(202))
        AMP2(203)=AMP2(203)+AMP(203)*DCONJG(AMP(203))
        AMP2(204)=AMP2(204)+AMP(204)*DCONJG(AMP(204))
        AMP2(205)=AMP2(205)+AMP(205)*DCONJG(AMP(205))
        AMP2(206)=AMP2(206)+AMP(206)*DCONJG(AMP(206))
        AMP2(207)=AMP2(207)+AMP(207)*DCONJG(AMP(207))
        AMP2(208)=AMP2(208)+AMP(208)*DCONJG(AMP(208))
        AMP2(209)=AMP2(209)+AMP(209)*DCONJG(AMP(209))
        AMP2(210)=AMP2(210)+AMP(210)*DCONJG(AMP(210))
        AMP2(211)=AMP2(211)+AMP(211)*DCONJG(AMP(211))
        AMP2(212)=AMP2(212)+AMP(212)*DCONJG(AMP(212))
        AMP2(213)=AMP2(213)+AMP(213)*DCONJG(AMP(213))
        AMP2(214)=AMP2(214)+AMP(214)*DCONJG(AMP(214))
        AMP2(215)=AMP2(215)+AMP(215)*DCONJG(AMP(215))
        AMP2(216)=AMP2(216)+AMP(216)*DCONJG(AMP(216))
        AMP2(217)=AMP2(217)+AMP(217)*DCONJG(AMP(217))
        AMP2(218)=AMP2(218)+AMP(218)*DCONJG(AMP(218))
        AMP2(219)=AMP2(219)+AMP(219)*DCONJG(AMP(219))
        AMP2(220)=AMP2(220)+AMP(220)*DCONJG(AMP(220))
      ENDIF

      DO I = 1, NCOLOR
        DO M = 1, NAMPSO
          DO N = 1, NAMPSO

            JAMP2(I)=JAMP2(I)+DABS(DBLE(JAMP(I,M)*DCONJG(JAMP(I,N))))

          ENDDO
        ENDDO
      ENDDO

      END

      SUBROUTINE PRINT_ZERO_AMP_1()

      IMPLICIT NONE
      INTEGER    NGRAPHS
      PARAMETER (NGRAPHS=220)

      INTEGER    NCOMB
      PARAMETER (NCOMB=256)

      LOGICAL ZEROAMP_1(NCOMB, NGRAPHS)
      COMMON/TO_ZEROAMP_1/ZEROAMP_1

      INTEGER I,J
      LOGICAL ALL_FALSE

      DO I=1, NGRAPHS
        ALL_FALSE = .TRUE.
        DO J=1,NCOMB
          IF (.NOT.ZEROAMP_1(J, I)) THEN
            ALL_FALSE = .FALSE.
            EXIT
          ENDIF
        ENDDO
        IF (ALL_FALSE) THEN
          WRITE(*,*) 'Amplitude/ZEROAMP:', 1, I
        ELSE
          DO J=1,NCOMB
            IF (ZEROAMP_1(J, I)) THEN
              WRITE(*,*) 'HEL/ZEROAMP:', 1, J  , I
            ENDIF
          ENDDO
        ENDIF
      ENDDO

      RETURN
      END
C     Set of functions to handle the array indices of the split orders


      INTEGER FUNCTION SQSOINDEX1(ORDERINDEXA, ORDERINDEXB)
C     
C     This functions plays the role of the interference matrix. It can
C      be hardcoded or 
C     made more elegant using hashtables if its execution speed ever
C      becomes a relevant
C     factor. From two split order indices, it return the
C      corresponding index in the squared 
C     order canonical ordering.
C     
C     CONSTANTS
C     

      INTEGER    NSO, NSQUAREDSO, NAMPSO
      PARAMETER (NSO=1, NSQUAREDSO=1, NAMPSO=1)
C     
C     ARGUMENTS
C     
      INTEGER ORDERINDEXA, ORDERINDEXB
C     
C     LOCAL VARIABLES
C     
      INTEGER I, SQORDERS(NSO)
      INTEGER AMPSPLITORDERS(NAMPSO,NSO)
      DATA (AMPSPLITORDERS(  1,I),I=  1,  1) /    1/
      COMMON/AMPSPLITORDERS1/AMPSPLITORDERS
C     
C     FUNCTION
C     
      INTEGER SOINDEX_FOR_SQUARED_ORDERS1
C     
C     BEGIN CODE
C     
      DO I=1,NSO
        SQORDERS(I)=AMPSPLITORDERS(ORDERINDEXA,I)
     $   +AMPSPLITORDERS(ORDERINDEXB,I)
      ENDDO
      SQSOINDEX1=SOINDEX_FOR_SQUARED_ORDERS1(SQORDERS)
      END

      INTEGER FUNCTION SOINDEX_FOR_SQUARED_ORDERS1(ORDERS)
C     
C     This functions returns the integer index identifying the squared
C      split orders list passed in argument which corresponds to the
C      values of the following list of couplings (and in this order).
C     []
C     
C     CONSTANTS
C     
      INTEGER    NSO, NSQSO, NAMPSO
      PARAMETER (NSO=1, NSQSO=1, NAMPSO=1)
C     
C     ARGUMENTS
C     
      INTEGER ORDERS(NSO)
C     
C     LOCAL VARIABLES
C     
      INTEGER I,J
      INTEGER SQSPLITORDERS(NSQSO,NSO)
      DATA (SQSPLITORDERS(  1,I),I=  1,  1) /    2/
      COMMON/SQPLITORDERS1/SQPLITORDERS
C     
C     BEGIN CODE
C     
      DO I=1,NSQSO
        DO J=1,NSO
          IF (ORDERS(J).NE.SQSPLITORDERS(I,J)) GOTO 1009
        ENDDO
        SOINDEX_FOR_SQUARED_ORDERS1 = I
        RETURN
 1009   CONTINUE
      ENDDO

      WRITE(*,*) 'ERROR:: Stopping in function'
      WRITE(*,*) 'SOINDEX_FOR_SQUARED_ORDERS1'
      WRITE(*,*) 'Could not find squared orders ',(ORDERS(I),I=1,NSO)
      STOP

      END

      SUBROUTINE GET_NSQSO_BORN1(NSQSO)
C     
C     Simple subroutine returning the number of squared split order
C     contributions returned when calling smatrix_split_orders 
C     

      INTEGER    NSQUAREDSO
      PARAMETER  (NSQUAREDSO=1)

      INTEGER NSQSO

      NSQSO=NSQUAREDSO

      END

C     This is the inverse subroutine of SOINDEX_FOR_SQUARED_ORDERS.
C      Not directly useful, but provided nonetheless.
      SUBROUTINE GET_SQUARED_ORDERS_FOR_SOINDEX1(SOINDEX,ORDERS)
C     
C     This functions returns the orders identified by the squared
C      split order index in argument. Order values correspond to
C      following list of couplings (and in this order):
C     []
C     
C     CONSTANTS
C     
      INTEGER    NSO, NSQSO
      PARAMETER (NSO=1, NSQSO=1)
C     
C     ARGUMENTS
C     
      INTEGER SOINDEX, ORDERS(NSO)
C     
C     LOCAL VARIABLES
C     
      INTEGER I
      INTEGER SQPLITORDERS(NSQSO,NSO)
      COMMON/SQPLITORDERS1/SQPLITORDERS
C     
C     BEGIN CODE
C     
      IF (SOINDEX.GT.0.AND.SOINDEX.LE.NSQSO) THEN
        DO I=1,NSO
          ORDERS(I) =  SQPLITORDERS(SOINDEX,I)
        ENDDO
        RETURN
      ENDIF

      WRITE(*,*) 'ERROR:: Stopping function'
     $ //' GET_SQUARED_ORDERS_FOR_SOINDEX1'
      WRITE(*,*) 'Could not find squared orders index ',SOINDEX
      STOP

      END SUBROUTINE

C     This is the inverse subroutine of getting amplitude SO orders.
C      Not directly useful, but provided nonetheless.
      SUBROUTINE GET_ORDERS_FOR_AMPSOINDEX1(SOINDEX,ORDERS)
C     
C     This functions returns the orders identified by the split order
C      index in argument. Order values correspond to following list of
C      couplings (and in this order):
C     []
C     
C     CONSTANTS
C     
      INTEGER    NSO, NAMPSO
      PARAMETER (NSO=1, NAMPSO=1)
C     
C     ARGUMENTS
C     
      INTEGER SOINDEX, ORDERS(NSO)
C     
C     LOCAL VARIABLES
C     
      INTEGER I
      INTEGER AMPSPLITORDERS(NAMPSO,NSO)
      COMMON/AMPSPLITORDERS1/AMPSPLITORDERS
C     
C     BEGIN CODE
C     
      IF (SOINDEX.GT.0.AND.SOINDEX.LE.NAMPSO) THEN
        DO I=1,NSO
          ORDERS(I) =  AMPSPLITORDERS(SOINDEX,I)
        ENDDO
        RETURN
      ENDIF

      WRITE(*,*) 'ERROR:: Stopping function GET_ORDERS_FOR_AMPSOINDEX1'
      WRITE(*,*) 'Could not find amplitude split orders index ',SOINDEX
      STOP

      END SUBROUTINE

C     This function is not directly useful, but included for
C      completeness
      INTEGER FUNCTION SOINDEX_FOR_AMPORDERS1(ORDERS)
C     
C     This functions returns the integer index identifying the
C      amplitude split orders passed in argument which correspond to
C      the values of the following list of couplings (and in this
C      order):
C     []
C     
C     CONSTANTS
C     
      INTEGER    NSO, NAMPSO
      PARAMETER (NSO=1, NAMPSO=1)
C     
C     ARGUMENTS
C     
      INTEGER ORDERS(NSO)
C     
C     LOCAL VARIABLES
C     
      INTEGER I,J
      INTEGER AMPSPLITORDERS(NAMPSO,NSO)
      COMMON/AMPSPLITORDERS1/AMPSPLITORDERS
C     
C     BEGIN CODE
C     
      DO I=1,NAMPSO
        DO J=1,NSO
          IF (ORDERS(J).NE.AMPSPLITORDERS(I,J)) GOTO 1009
        ENDDO
        SOINDEX_FOR_AMPORDERS1 = I
        RETURN
 1009   CONTINUE
      ENDDO

      WRITE(*,*) 'ERROR:: Stopping function SOINDEX_FOR_AMPORDERS1'
      WRITE(*,*) 'Could not find squared orders ',(ORDERS(I),I=1,NSO)
      STOP

      END

